/* snul-gio.c generated by valac, the Vala compiler
 * generated from snul-gio.vala, do not modify */

/*
 * based on: snul.vala (part of Snul)
 *
 * Snul: is a simple library that implements
 *       a tcp socket client in vala
 *
 * Copyright (C) 2008  Andrea Del Signore
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 *
 * Author:
 *     Andrea Del Signore <sejerpz@tin.it>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define SNUL_TYPE_TCP_CLIENT (snul_tcp_client_get_type ())
#define SNUL_TCP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SNUL_TYPE_TCP_CLIENT, SnulTcpClient))
#define SNUL_TCP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SNUL_TYPE_TCP_CLIENT, SnulTcpClientClass))
#define SNUL_IS_TCP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SNUL_TYPE_TCP_CLIENT))
#define SNUL_IS_TCP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SNUL_TYPE_TCP_CLIENT))
#define SNUL_TCP_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SNUL_TYPE_TCP_CLIENT, SnulTcpClientClass))

typedef struct _SnulTcpClient SnulTcpClient;
typedef struct _SnulTcpClientClass SnulTcpClientClass;
typedef struct _SnulTcpClientPrivate SnulTcpClientPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SnulTcpClientConnectData SnulTcpClientConnectData;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

typedef enum  {
	SNUL_TCP_SOCKET_ERROR_LOOKUP_SERVICE_FAILED,
	SNUL_TCP_SOCKET_ERROR_LOOKUP_HOSTNAME_FAILED,
	SNUL_TCP_SOCKET_ERROR_SOCKET_CREATION_ERROR,
	SNUL_TCP_SOCKET_ERROR_SOCKET_CONNECT_ERROR,
	SNUL_TCP_SOCKET_ERROR_SOCKET_ALREADY_OPEN,
	SNUL_TCP_SOCKET_ERROR_SOCKET_CLOSED,
	SNUL_TCP_SOCKET_ERROR_SOCKET_BROKEN,
	SNUL_TCP_SOCKET_ERROR_SOCKET_HUP,
	SNUL_TCP_SOCKET_ERROR_IOCHANNEL_ERROR,
	SNUL_TCP_SOCKET_ERROR_IOCHANNEL_NVAL,
	SNUL_TCP_SOCKET_ERROR_OPERATION_TIMEOUT
} SnulTcpSocketError;
#define SNUL_TCP_SOCKET_ERROR snul_tcp_socket_error_quark ()
struct _SnulTcpClient {
	GObject parent_instance;
	SnulTcpClientPrivate * priv;
};

struct _SnulTcpClientClass {
	GObjectClass parent_class;
	void (*on_connected) (SnulTcpClient* self, GSocketConnection* client);
	void (*on_data_received) (SnulTcpClient* self, const char* buffer, gsize len);
	void (*on_disconnected) (SnulTcpClient* self);
	void (*on_error) (SnulTcpClient* self, GError* _error_);
};

struct _SnulTcpClientPrivate {
	char* _address;
	char* _first_address;
	char* _port;
	GResolver* _resolver;
	GInetAddress* _inet_address;
	GSocketClient* _client;
	GSocketConnection* _connection;
	GIOChannel* _in_channel;
	GSource* _source;
	guint _source_id;
	GDataInputStream* _input;
	GCancellable* _cancellable;
	guint _timeout_id;
};

struct _SnulTcpClientConnectData {
	int _state_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	SnulTcpClient* self;
	char* address;
	char* port;
	char* _tmp0_;
	char* _tmp1_;
	GCancellable* _tmp2_;
	GResolver* _tmp3_;
	GList* results;
	GInetAddress* _tmp4_;
	GInetSocketAddress* socket_address;
	GSocketClient* _tmp5_;
	GSocketConnection* _tmp6_;
	GSocketConnection* _tmp7_;
	GCancellable* _tmp8_;
	GDataInputStream* _tmp9_;
	GIOCondition conditions;
	GIOChannel* _tmp10_;
	GError * err;
	GError * _inner_error_;
};


static gpointer snul_tcp_client_parent_class = NULL;

GQuark snul_tcp_socket_error_quark (void);
GType snul_tcp_client_get_type (void);
#define SNUL_TCP_CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SNUL_TYPE_TCP_CLIENT, SnulTcpClientPrivate))
enum  {
	SNUL_TCP_CLIENT_DUMMY_PROPERTY,
	SNUL_TCP_CLIENT_ADDRESS,
	SNUL_TCP_CLIENT_FIRST_ADDRESS,
	SNUL_TCP_CLIENT_PORT
};
#define SNUL_TCP_CLIENT_TimeoutValue 10
static void snul_tcp_client_connect_data_free (gpointer _data);
static void snul_tcp_client_connect_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean snul_tcp_client_on_operation_timed_out (SnulTcpClient* self);
static gboolean _snul_tcp_client_on_operation_timed_out_gsource_func (gpointer self);
static void _g_list_free_g_object_unref (GList* self);
static gboolean snul_tcp_client_socket_callback (SnulTcpClient* self, GIOChannel* source, GIOCondition condition);
static gboolean _snul_tcp_client_socket_callback_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
void snul_tcp_client_on_error (SnulTcpClient* self, GError* _error_);
void snul_tcp_client_connect (SnulTcpClient* self, const char* address, const char* port, GAsyncReadyCallback _callback_, gpointer _user_data_);
void snul_tcp_client_connect_finish (SnulTcpClient* self, GAsyncResult* _res_, GError** error);
static gboolean snul_tcp_client_connect_co (SnulTcpClientConnectData* data);
gsize snul_tcp_client_send (SnulTcpClient* self, const char* buffer);
static void snul_tcp_client_cleanup (SnulTcpClient* self);
void snul_tcp_client_on_disconnected (SnulTcpClient* self);
void snul_tcp_client_disconnect (SnulTcpClient* self);
void snul_tcp_client_on_connected (SnulTcpClient* self, GSocketConnection* client);
static void snul_tcp_client_real_on_connected (SnulTcpClient* self, GSocketConnection* client);
void snul_tcp_client_on_data_received (SnulTcpClient* self, const char* buffer, gsize len);
static void snul_tcp_client_real_on_data_received (SnulTcpClient* self, const char* buffer, gsize len);
static void snul_tcp_client_real_on_disconnected (SnulTcpClient* self);
static void snul_tcp_client_real_on_error (SnulTcpClient* self, GError* _error_);
SnulTcpClient* snul_tcp_client_new (void);
SnulTcpClient* snul_tcp_client_construct (GType object_type);
const char* snul_tcp_client_get_address (SnulTcpClient* self);
const char* snul_tcp_client_get_first_address (SnulTcpClient* self);
void snul_tcp_client_set_first_address (SnulTcpClient* self, const char* value);
const char* snul_tcp_client_get_port (SnulTcpClient* self);
static void snul_tcp_client_finalize (GObject* obj);
static void snul_tcp_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void snul_tcp_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void g_cclosure_user_marshal_VOID__STRING_ULONG (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

GQuark snul_tcp_socket_error_quark (void) {
	return g_quark_from_static_string ("snul_tcp_socket_error-quark");
}


static void snul_tcp_client_connect_data_free (gpointer _data) {
	SnulTcpClientConnectData* data;
	data = _data;
	_g_free0 (data->address);
	_g_free0 (data->port);
	g_slice_free (SnulTcpClientConnectData, data);
}


void snul_tcp_client_connect (SnulTcpClient* self, const char* address, const char* port, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	SnulTcpClientConnectData* _data_;
	_data_ = g_slice_new0 (SnulTcpClientConnectData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, snul_tcp_client_connect);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, snul_tcp_client_connect_data_free);
	_data_->self = self;
	_data_->address = g_strdup (address);
	_data_->port = g_strdup (port);
	snul_tcp_client_connect_co (_data_);
}


void snul_tcp_client_connect_finish (SnulTcpClient* self, GAsyncResult* _res_, GError** error) {
	SnulTcpClientConnectData* _data_;
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
		return;
	}
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void snul_tcp_client_connect_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	SnulTcpClientConnectData* data;
	data = _user_data_;
	data->_res_ = _res_;
	snul_tcp_client_connect_co (data);
}


static gboolean _snul_tcp_client_on_operation_timed_out_gsource_func (gpointer self) {
	return snul_tcp_client_on_operation_timed_out (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static gboolean _snul_tcp_client_socket_callback_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	return snul_tcp_client_socket_callback (self, source, condition);
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static gboolean snul_tcp_client_connect_co (SnulTcpClientConnectData* data) {
	switch (data->_state_) {
		default:
		g_assert_not_reached ();
		case 0:
		{
			{
				if (data->self->priv->_client != NULL) {
					data->_inner_error_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_SOCKET_ALREADY_OPEN, "Socket already opened");
					if (data->_inner_error_ != NULL) {
						goto __catch10_g_error;
						goto __finally10;
					}
				}
				data->self->priv->_address = (data->_tmp0_ = g_strdup (data->address), _g_free0 (data->self->priv->_address), data->_tmp0_);
				data->self->priv->_port = (data->_tmp1_ = g_strdup (data->port), _g_free0 (data->self->priv->_port), data->_tmp1_);
				data->self->priv->_cancellable = (data->_tmp2_ = g_cancellable_new (), _g_object_unref0 (data->self->priv->_cancellable), data->_tmp2_);
				data->self->priv->_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) SNUL_TCP_CLIENT_TimeoutValue, _snul_tcp_client_on_operation_timed_out_gsource_func, g_object_ref (data->self), g_object_unref);
				data->self->priv->_resolver = (data->_tmp3_ = _g_object_ref0 (g_resolver_get_default ()), _g_object_unref0 (data->self->priv->_resolver), data->_tmp3_);
				g_resolver_lookup_by_name_async (data->self->priv->_resolver, data->self->priv->_address, data->self->priv->_cancellable, snul_tcp_client_connect_ready, data);
				data->_state_ = 1;
				return FALSE;
				case 1:
				data->results = g_resolver_lookup_by_name_finish (data->self->priv->_resolver, data->_res_, &data->_inner_error_);
				if (data->_inner_error_ != NULL) {
					goto __catch10_g_error;
					goto __finally10;
				}
				if (data->results != NULL) {
					data->self->priv->_inet_address = (data->_tmp4_ = _g_object_ref0 (G_INET_ADDRESS ((GInetAddress*) g_list_nth_data (data->results, (guint) 0))), _g_object_unref0 (data->self->priv->_inet_address), data->_tmp4_);
					data->socket_address = (GInetSocketAddress*) g_inet_socket_address_new (data->self->priv->_inet_address, (guint16) ((gushort) atoi (data->self->priv->_port)));
					data->self->priv->_client = (data->_tmp5_ = g_socket_client_new (), _g_object_unref0 (data->self->priv->_client), data->_tmp5_);
					g_socket_client_connect_async (data->self->priv->_client, (GSocketConnectable*) data->socket_address, data->self->priv->_cancellable, snul_tcp_client_connect_ready, data);
					data->_state_ = 2;
					return FALSE;
					case 2:
					data->_tmp6_ = g_socket_client_connect_finish (data->self->priv->_client, data->_res_, &data->_inner_error_);
					if (data->_inner_error_ != NULL) {
						_g_object_unref0 (data->socket_address);
						__g_list_free_g_object_unref0 (data->results);
						goto __catch10_g_error;
						goto __finally10;
					}
					data->self->priv->_connection = (data->_tmp7_ = _g_object_ref0 (data->_tmp6_), _g_object_unref0 (data->self->priv->_connection), data->_tmp7_);
					data->self->priv->_cancellable = (data->_tmp8_ = NULL, _g_object_unref0 (data->self->priv->_cancellable), data->_tmp8_);
					g_socket_set_blocking (g_socket_connection_get_socket (data->self->priv->_connection), FALSE);
					data->self->priv->_input = (data->_tmp9_ = g_data_input_stream_new (g_io_stream_get_input_stream ((GIOStream*) data->self->priv->_connection)), _g_object_unref0 (data->self->priv->_input), data->_tmp9_);
					data->conditions = ((G_IO_IN | G_IO_HUP) | G_IO_ERR) | G_IO_NVAL;
					data->self->priv->_in_channel = (data->_tmp10_ = g_io_channel_unix_new (g_socket_get_fd (g_socket_connection_get_socket (data->self->priv->_connection))), _g_io_channel_unref0 (data->self->priv->_in_channel), data->_tmp10_);
					data->self->priv->_source_id = g_io_add_watch (data->self->priv->_in_channel, data->conditions, _snul_tcp_client_socket_callback_gio_func, data->self);
					g_signal_emit_by_name (data->self, "connected", data->self->priv->_connection);
					if (data->self->priv->_timeout_id != 0) {
						g_source_remove (data->self->priv->_timeout_id);
						data->self->priv->_timeout_id = (guint) 0;
					}
					_g_object_unref0 (data->socket_address);
				}
				__g_list_free_g_object_unref0 (data->results);
			}
			goto __finally10;
			__catch10_g_error:
			{
				data->err = data->_inner_error_;
				data->_inner_error_ = NULL;
				{
					snul_tcp_client_on_error (data->self, data->err);
					data->_inner_error_ = _g_error_copy0 (data->err);
					if (data->_inner_error_ != NULL) {
						_g_error_free0 (data->err);
						goto __finally10;
					}
					_g_error_free0 (data->err);
				}
			}
			__finally10:
			if (data->_inner_error_ != NULL) {
				g_simple_async_result_set_from_error (data->_async_result, data->_inner_error_);
				g_error_free (data->_inner_error_);
				{
					if (data->_state_ == 0) {
						g_simple_async_result_complete_in_idle (data->_async_result);
					} else {
						g_simple_async_result_complete (data->_async_result);
					}
					g_object_unref (data->_async_result);
					return FALSE;
				}
			}
		}
		{
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
	}
}


static gboolean snul_tcp_client_on_operation_timed_out (SnulTcpClient* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->_cancellable != NULL) {
		_tmp0_ = !g_cancellable_is_cancelled (self->priv->_cancellable);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GError* _tmp1_;
		g_cancellable_cancel (self->priv->_cancellable);
		snul_tcp_client_on_error (self, _tmp1_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_OPERATION_TIMEOUT, "Operation timeout"));
		_g_error_free0 (_tmp1_);
	}
	self->priv->_timeout_id = (guint) 0;
	result = FALSE;
	return result;
}


gsize snul_tcp_client_send (SnulTcpClient* self, const char* buffer) {
	gsize result;
	GError * _inner_error_;
	gsize bytes_written;
	g_return_val_if_fail (self != NULL, 0UL);
	g_return_val_if_fail (buffer != NULL, 0UL);
	_inner_error_ = NULL;
	bytes_written = (gsize) 0;
	{
		gboolean _tmp0_ = FALSE;
		if (self->priv->_connection != NULL) {
			_tmp0_ = g_io_stream_get_output_stream ((GIOStream*) self->priv->_connection) != NULL;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			g_output_stream_write (g_io_stream_get_output_stream ((GIOStream*) self->priv->_connection), buffer, (gsize) g_utf8_strlen (buffer, -1), NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch11_g_error;
				goto __finally11;
			}
		}
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("snul-gio.vala:143: error writing: %s", err->message);
			snul_tcp_client_on_error (self, err);
			_g_error_free0 (err);
		}
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0UL;
	}
	result = bytes_written;
	return result;
}


void snul_tcp_client_disconnect (SnulTcpClient* self) {
	g_return_if_fail (self != NULL);
	snul_tcp_client_cleanup (self);
	snul_tcp_client_on_disconnected (self);
}


static void snul_tcp_client_cleanup (SnulTcpClient* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		g_source_remove_by_user_data (self);
		if (self->priv->_source_id != 0) {
			g_source_remove (self->priv->_source_id);
			self->priv->_source_id = (guint) 0;
		}
		if (self->priv->_source != NULL) {
			GSource* _tmp0_;
			g_source_destroy (self->priv->_source);
			self->priv->_source = (_tmp0_ = NULL, _g_source_unref0 (self->priv->_source), _tmp0_);
		}
		if (self->priv->_connection != NULL) {
			GDataInputStream* _tmp1_;
			GIOChannel* _tmp2_;
			GSocketConnection* _tmp3_;
			self->priv->_input = (_tmp1_ = NULL, _g_object_unref0 (self->priv->_input), _tmp1_);
			self->priv->_in_channel = (_tmp2_ = NULL, _g_io_channel_unref0 (self->priv->_in_channel), _tmp2_);
			g_io_stream_close ((GIOStream*) self->priv->_connection, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch12_g_error;
				goto __finally12;
			}
			self->priv->_connection = (_tmp3_ = NULL, _g_object_unref0 (self->priv->_connection), _tmp3_);
		}
		if (self->priv->_client != NULL) {
			GSocketClient* _tmp4_;
			self->priv->_client = (_tmp4_ = NULL, _g_object_unref0 (self->priv->_client), _tmp4_);
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("snul-gio.vala:182: error cleanup: %s", err->message);
			snul_tcp_client_on_error (self, err);
			_g_error_free0 (err);
		}
	}
	__finally12:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void snul_tcp_client_real_on_connected (SnulTcpClient* self, GSocketConnection* client) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_signal_emit_by_name (self, "connected", client);
}


void snul_tcp_client_on_connected (SnulTcpClient* self, GSocketConnection* client) {
	SNUL_TCP_CLIENT_GET_CLASS (self)->on_connected (self, client);
}


static void snul_tcp_client_real_on_data_received (SnulTcpClient* self, const char* buffer, gsize len) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (buffer != NULL);
	g_signal_emit_by_name (self, "data-received", buffer, len);
}


void snul_tcp_client_on_data_received (SnulTcpClient* self, const char* buffer, gsize len) {
	SNUL_TCP_CLIENT_GET_CLASS (self)->on_data_received (self, buffer, len);
}


static void snul_tcp_client_real_on_disconnected (SnulTcpClient* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "disconnected");
}


void snul_tcp_client_on_disconnected (SnulTcpClient* self) {
	SNUL_TCP_CLIENT_GET_CLASS (self)->on_disconnected (self);
}


static void snul_tcp_client_real_on_error (SnulTcpClient* self, GError* _error_) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "error", _error_);
}


void snul_tcp_client_on_error (SnulTcpClient* self, GError* _error_) {
	SNUL_TCP_CLIENT_GET_CLASS (self)->on_error (self, _error_);
}


static gboolean snul_tcp_client_socket_callback (SnulTcpClient* self, GIOChannel* source, GIOCondition condition) {
	gboolean result;
	GError * _inner_error_;
	gboolean res;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_inner_error_ = NULL;
	res = TRUE;
	switch (condition) {
		case G_IO_IN:
		{
			gsize length;
			GString* message;
			length = (gsize) (-1);
			message = g_string_new ("");
			while (TRUE) {
				if (!(length != 0)) {
					break;
				}
				{
					char* buffer;
					buffer = g_data_input_stream_read_line (self->priv->_input, &length, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_IO_ERROR) {
							goto __catch13_g_io_error;
						}
						goto __finally13;
					}
					if (buffer != NULL) {
						g_string_append_printf (message, "%s\n", buffer);
					}
					_g_free0 (buffer);
				}
				goto __finally13;
				__catch13_g_io_error:
				{
					GError * err;
					err = _inner_error_;
					_inner_error_ = NULL;
					{
						if (err->code != 27) {
							snul_tcp_client_on_error (self, err);
						}
						length = (gsize) 0;
						_g_error_free0 (err);
					}
				}
				__finally13:
				if (_inner_error_ != NULL) {
					_g_string_free0 (message);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return FALSE;
				}
			}
			if (message->len > 0) {
				snul_tcp_client_on_data_received (self, message->str, (gsize) message->len);
			} else {
				GError* _tmp0_;
				snul_tcp_client_on_error (self, _tmp0_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_SOCKET_BROKEN, "zero length data, socket broken? Closing connection."));
				_g_error_free0 (_tmp0_);
				snul_tcp_client_disconnect (self);
			}
			_g_string_free0 (message);
			break;
		}
		case G_IO_HUP:
		{
			GError* _tmp1_;
			snul_tcp_client_on_error (self, _tmp1_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_SOCKET_HUP, "Socket HUP"));
			_g_error_free0 (_tmp1_);
			snul_tcp_client_disconnect (self);
			res = FALSE;
			break;
		}
		case G_IO_ERR:
		{
			GError* _tmp2_;
			snul_tcp_client_on_error (self, _tmp2_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_IOCHANNEL_ERROR, "IOChannel error (ERR)"));
			_g_error_free0 (_tmp2_);
			snul_tcp_client_disconnect (self);
			break;
		}
		case G_IO_NVAL:
		{
			GError* _tmp3_;
			snul_tcp_client_on_error (self, _tmp3_ = g_error_new_literal (SNUL_TCP_SOCKET_ERROR, SNUL_TCP_SOCKET_ERROR_IOCHANNEL_NVAL, "IOChannel invalid request (NAVL)"));
			_g_error_free0 (_tmp3_);
			snul_tcp_client_disconnect (self);
			break;
		}
	}
	result = res;
	return result;
}


SnulTcpClient* snul_tcp_client_construct (GType object_type) {
	SnulTcpClient * self;
	self = (SnulTcpClient*) g_object_new (object_type, NULL);
	return self;
}


SnulTcpClient* snul_tcp_client_new (void) {
	return snul_tcp_client_construct (SNUL_TYPE_TCP_CLIENT);
}


const char* snul_tcp_client_get_address (SnulTcpClient* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_address;
	return result;
}


const char* snul_tcp_client_get_first_address (SnulTcpClient* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = snul_tcp_client_get_address (self);
	return result;
}


void snul_tcp_client_set_first_address (SnulTcpClient* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_first_address = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_first_address), _tmp0_);
	g_object_notify ((GObject *) self, "first-address");
}


const char* snul_tcp_client_get_port (SnulTcpClient* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_port;
	return result;
}


static void snul_tcp_client_class_init (SnulTcpClientClass * klass) {
	snul_tcp_client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SnulTcpClientPrivate));
	SNUL_TCP_CLIENT_CLASS (klass)->on_connected = snul_tcp_client_real_on_connected;
	SNUL_TCP_CLIENT_CLASS (klass)->on_data_received = snul_tcp_client_real_on_data_received;
	SNUL_TCP_CLIENT_CLASS (klass)->on_disconnected = snul_tcp_client_real_on_disconnected;
	SNUL_TCP_CLIENT_CLASS (klass)->on_error = snul_tcp_client_real_on_error;
	G_OBJECT_CLASS (klass)->get_property = snul_tcp_client_get_property;
	G_OBJECT_CLASS (klass)->set_property = snul_tcp_client_set_property;
	G_OBJECT_CLASS (klass)->finalize = snul_tcp_client_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNUL_TCP_CLIENT_ADDRESS, g_param_spec_string ("address", "address", "address", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNUL_TCP_CLIENT_FIRST_ADDRESS, g_param_spec_string ("first-address", "first-address", "first-address", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SNUL_TCP_CLIENT_PORT, g_param_spec_string ("port", "port", "port", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("connected", SNUL_TYPE_TCP_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_SOCKET_CONNECTION);
	g_signal_new ("data_received", SNUL_TYPE_TCP_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ULONG, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_ULONG);
	g_signal_new ("disconnected", SNUL_TYPE_TCP_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("error", SNUL_TYPE_TCP_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
}


static void snul_tcp_client_instance_init (SnulTcpClient * self) {
	self->priv = SNUL_TCP_CLIENT_GET_PRIVATE (self);
	self->priv->_address = NULL;
	self->priv->_first_address = NULL;
	self->priv->_port = NULL;
	self->priv->_resolver = NULL;
	self->priv->_inet_address = NULL;
	self->priv->_client = NULL;
	self->priv->_connection = NULL;
	self->priv->_in_channel = NULL;
	self->priv->_source = NULL;
	self->priv->_source_id = (guint) 0;
	self->priv->_input = NULL;
	self->priv->_cancellable = NULL;
	self->priv->_timeout_id = (guint) 0;
}


static void snul_tcp_client_finalize (GObject* obj) {
	SnulTcpClient * self;
	self = SNUL_TCP_CLIENT (obj);
	{
		snul_tcp_client_cleanup (self);
	}
	_g_free0 (self->priv->_address);
	_g_free0 (self->priv->_first_address);
	_g_free0 (self->priv->_port);
	_g_object_unref0 (self->priv->_resolver);
	_g_object_unref0 (self->priv->_inet_address);
	_g_object_unref0 (self->priv->_client);
	_g_object_unref0 (self->priv->_connection);
	_g_io_channel_unref0 (self->priv->_in_channel);
	_g_source_unref0 (self->priv->_source);
	_g_object_unref0 (self->priv->_input);
	_g_object_unref0 (self->priv->_cancellable);
	G_OBJECT_CLASS (snul_tcp_client_parent_class)->finalize (obj);
}


GType snul_tcp_client_get_type (void) {
	static GType snul_tcp_client_type_id = 0;
	if (snul_tcp_client_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (SnulTcpClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) snul_tcp_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SnulTcpClient), 0, (GInstanceInitFunc) snul_tcp_client_instance_init, NULL };
		snul_tcp_client_type_id = g_type_register_static (G_TYPE_OBJECT, "SnulTcpClient", &g_define_type_info, 0);
	}
	return snul_tcp_client_type_id;
}


static void snul_tcp_client_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SnulTcpClient * self;
	self = SNUL_TCP_CLIENT (object);
	switch (property_id) {
		case SNUL_TCP_CLIENT_ADDRESS:
		g_value_set_string (value, snul_tcp_client_get_address (self));
		break;
		case SNUL_TCP_CLIENT_FIRST_ADDRESS:
		g_value_set_string (value, snul_tcp_client_get_first_address (self));
		break;
		case SNUL_TCP_CLIENT_PORT:
		g_value_set_string (value, snul_tcp_client_get_port (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void snul_tcp_client_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SnulTcpClient * self;
	self = SNUL_TCP_CLIENT (object);
	switch (property_id) {
		case SNUL_TCP_CLIENT_FIRST_ADDRESS:
		snul_tcp_client_set_first_address (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



static void g_cclosure_user_marshal_VOID__STRING_ULONG (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_ULONG) (gpointer data1, const char* arg_1, gsize arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ULONG callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_ULONG) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_ulong (param_values + 2), data2);
}



