/* tuntun-auth-dialog.c generated by valac, the Vala compiler
 * generated from tuntun-auth-dialog.vala, do not modify */

/*
 *  tuntun-auth-dialog.vala is a part of Tuntun
 *
 *  Tuntun: a simple applet to manage OpenVPN connections
 *
 *  Copyright (C) 2008  Andrea Del Signore
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 *  Author:
 *     Andrea Del Signore <sejerpz@tin.it>       
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <glib/gi18n-lib.h>
#include <gnome-keyring.h>


#define TUNTUN_TYPE_AUTH_STEPS (tuntun_auth_steps_get_type ())

#define TUNTUN_TYPE_AUTH_DIALOG (tuntun_auth_dialog_get_type ())
#define TUNTUN_AUTH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_AUTH_DIALOG, TuntunAuthDialog))
#define TUNTUN_AUTH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_AUTH_DIALOG, TuntunAuthDialogClass))
#define TUNTUN_IS_AUTH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_AUTH_DIALOG))
#define TUNTUN_IS_AUTH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_AUTH_DIALOG))
#define TUNTUN_AUTH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_AUTH_DIALOG, TuntunAuthDialogClass))

typedef struct _TuntunAuthDialog TuntunAuthDialog;
typedef struct _TuntunAuthDialogClass TuntunAuthDialogClass;
typedef struct _TuntunAuthDialogPrivate TuntunAuthDialogPrivate;

#define TUNTUN_TYPE_CONNECTION (tuntun_connection_get_type ())
#define TUNTUN_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnection))
#define TUNTUN_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))
#define TUNTUN_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))

typedef struct _TuntunConnection TuntunConnection;
typedef struct _TuntunConnectionClass TuntunConnectionClass;

#define TUNTUN_TYPE_AUTHENTICATION_MODES (tuntun_authentication_modes_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TUNTUN_TYPE_CONNECTION_INFO (tuntun_connection_info_get_type ())
#define TUNTUN_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfo))
#define TUNTUN_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))
#define TUNTUN_IS_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_IS_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_CONNECTION_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))

typedef struct _TuntunConnectionInfo TuntunConnectionInfo;
typedef struct _TuntunConnectionInfoClass TuntunConnectionInfoClass;

typedef enum  {
	TUNTUN_AUTH_STEPS_KEYRING,
	TUNTUN_AUTH_STEPS_DIALOG
} TuntunAuthSteps;

struct _TuntunAuthDialog {
	GtkWindow parent_instance;
	TuntunAuthDialogPrivate * priv;
};

struct _TuntunAuthDialogClass {
	GtkWindowClass parent_class;
};

typedef enum  {
	TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY,
	TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD
} TuntunAuthenticationModes;

struct _TuntunAuthDialogPrivate {
	TuntunConnection* _connection;
	TuntunAuthenticationModes _mode;
	char* _type;
	GtkEntry* _entry_user;
	GtkEntry* _entry_pass;
	GtkCheckButton* _checkbutton_save_in_keyring;
	guint _keyring_item_id;
	TuntunAuthSteps _current;
};


static gpointer tuntun_auth_dialog_parent_class = NULL;

GType tuntun_auth_steps_get_type (void);
GType tuntun_auth_dialog_get_type (void);
GType tuntun_connection_get_type (void);
GType tuntun_authentication_modes_get_type (void);
#define TUNTUN_AUTH_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TUNTUN_TYPE_AUTH_DIALOG, TuntunAuthDialogPrivate))
enum  {
	TUNTUN_AUTH_DIALOG_DUMMY_PROPERTY,
	TUNTUN_AUTH_DIALOG_CONNECTION,
	TUNTUN_AUTH_DIALOG_MODE,
	TUNTUN_AUTH_DIALOG_TYPE
};
TuntunAuthDialog* tuntun_auth_dialog_new (TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
TuntunAuthDialog* tuntun_auth_dialog_construct (GType object_type, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
char* tuntun_utils_get_ui_path (const char* id);
void tuntun_utils_display_error (const char* function, const char* message);
static void tuntun_auth_dialog_on_button_ok_clicked (TuntunAuthDialog* self, GtkButton* sender);
static void _tuntun_auth_dialog_on_button_ok_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void tuntun_auth_dialog_on_button_cancel_clicked (TuntunAuthDialog* self, GtkButton* sender);
static void _tuntun_auth_dialog_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
GType tuntun_connection_info_get_type (void);
TuntunConnectionInfo* tuntun_connection_get_info (TuntunConnection* self);
const char* tuntun_connection_info_get_name (TuntunConnectionInfo* self);
static void tuntun_auth_dialog_initialize_ui (TuntunAuthDialog* self);
static void tuntun_auth_dialog_authenticate_dialog_finish (TuntunAuthDialog* self, gboolean cancel);
static void tuntun_auth_dialog_on_item_delete_done (TuntunAuthDialog* self, GnomeKeyringResult _result_);
static void _tuntun_auth_dialog_on_item_delete_done_gnome_keyring_operation_done_callback (GnomeKeyringResult _result_, gpointer self);
static void tuntun_auth_dialog_on_connection_authentication_failed (TuntunAuthDialog* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
static void tuntun_auth_dialog_authenticate_keyring (TuntunAuthDialog* self);
void tuntun_auth_dialog_authenticate (TuntunAuthDialog* self);
static void tuntun_auth_dialog_authenticate_keyring_auth (TuntunAuthDialog* self);
static void tuntun_auth_dialog_authenticate_keyring_private_key (TuntunAuthDialog* self);
static void tuntun_auth_dialog_authenticate_dialog (TuntunAuthDialog* self);
void tuntun_connection_authenticate (TuntunConnection* self, const char* type, const char* username, const char* password);
static void tuntun_auth_dialog_save (TuntunAuthDialog* self, const char* username, const char* password);
static void tuntun_auth_dialog_save_private_key_password (TuntunAuthDialog* self, const char* private_key_password);
void tuntun_connection_cancel_authentication (TuntunConnection* self, const char* type, const char* username);
const char* tuntun_connection_info_get_address (TuntunConnectionInfo* self);
static void tuntun_auth_dialog_on_find_password_done (TuntunAuthDialog* self, GnomeKeyringResult _result_, GList* list);
static void _tuntun_auth_dialog_on_find_password_done_gnome_keyring_operation_get_list_callback (GnomeKeyringResult _result_, GList* list, gpointer self);
static void tuntun_auth_dialog_on_set_password_done (TuntunAuthDialog* self, GnomeKeyringResult _result_, guint32 val);
static void _tuntun_auth_dialog_on_set_password_done_gnome_keyring_operation_get_int_callback (GnomeKeyringResult _result_, guint32 val, gpointer self);
static void tuntun_auth_dialog_set_connection (TuntunAuthDialog* self, TuntunConnection* value);
static void tuntun_auth_dialog_set_mode (TuntunAuthDialog* self, TuntunAuthenticationModes value);
static void tuntun_auth_dialog_set_type (TuntunAuthDialog* self, const char* value);
static void _tuntun_auth_dialog_on_connection_authentication_failed_tuntun_connection_authentication_failed (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self);
static GObject * tuntun_auth_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tuntun_auth_dialog_finalize (GObject* obj);
static void tuntun_auth_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);




GType tuntun_auth_steps_get_type (void) {
	static GType tuntun_auth_steps_type_id = 0;
	if (G_UNLIKELY (tuntun_auth_steps_type_id == 0)) {
		static const GEnumValue values[] = {{TUNTUN_AUTH_STEPS_KEYRING, "TUNTUN_AUTH_STEPS_KEYRING", "keyring"}, {TUNTUN_AUTH_STEPS_DIALOG, "TUNTUN_AUTH_STEPS_DIALOG", "dialog"}, {0, NULL, NULL}};
		tuntun_auth_steps_type_id = g_enum_register_static ("TuntunAuthSteps", values);
	}
	return tuntun_auth_steps_type_id;
}


TuntunAuthDialog* tuntun_auth_dialog_construct (GType object_type, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	TuntunAuthDialog * self;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (type != NULL, NULL);
	self = (TuntunAuthDialog*) g_object_new (object_type, "connection", connection, "mode", mode, "type", type, NULL);
	return self;
}


TuntunAuthDialog* tuntun_auth_dialog_new (TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	return tuntun_auth_dialog_construct (TUNTUN_TYPE_AUTH_DIALOG, connection, mode, type);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _tuntun_auth_dialog_on_button_ok_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	tuntun_auth_dialog_on_button_ok_clicked (self, _sender);
}


static void _tuntun_auth_dialog_on_button_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	tuntun_auth_dialog_on_button_cancel_clicked (self, _sender);
}


static void tuntun_auth_dialog_initialize_ui (TuntunAuthDialog* self) {
	GError * _inner_error_;
	GtkBuilder* builder;
	GtkVBox* childs;
	GtkButton* button;
	GtkButton* _tmp1_;
	GtkLabel* label;
	GtkLabel* label_message;
	char* label_text;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	builder = gtk_builder_new ();
	gtk_builder_set_translation_domain (builder, GETTEXT_PACKAGE);
	{
		char* _tmp0_;
		gtk_builder_add_from_file (builder, _tmp0_ = tuntun_utils_get_ui_path ("tuntun-auth-dialog.ui"), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch9_g_error;
			goto __finally9;
		}
		_g_free0 (_tmp0_);
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			tuntun_utils_display_error ("initialize_ui", err->message);
			_g_error_free0 (err);
		}
	}
	__finally9:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	childs = _g_object_ref0 (GTK_VBOX (gtk_builder_get_object (builder, "vbox_authentication")));
	g_assert (childs != NULL);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) childs);
	g_object_set ((GObject*) self, "border-width", 12, NULL);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	button = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_auth_ok")));
	g_assert (button != NULL);
	g_signal_connect_object (button, "clicked", (GCallback) _tuntun_auth_dialog_on_button_ok_clicked_gtk_button_clicked, self, 0);
	button = (_tmp1_ = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_auth_cancel"))), _g_object_unref0 (button), _tmp1_);
	g_assert (button != NULL);
	g_signal_connect_object (button, "clicked", (GCallback) _tuntun_auth_dialog_on_button_cancel_clicked_gtk_button_clicked, self, 0);
	self->priv->_entry_user = GTK_ENTRY (gtk_builder_get_object (builder, "entry_username"));
	g_assert (self->priv->_entry_user != NULL);
	self->priv->_entry_pass = GTK_ENTRY (gtk_builder_get_object (builder, "entry_password"));
	g_assert (self->priv->_entry_pass != NULL);
	self->priv->_checkbutton_save_in_keyring = GTK_CHECK_BUTTON (gtk_builder_get_object (builder, "checkbutton_save_in_keyring"));
	g_assert (self->priv->_checkbutton_save_in_keyring != NULL);
	label = _g_object_ref0 (GTK_LABEL (gtk_builder_get_object (builder, "label_username")));
	label_message = _g_object_ref0 (GTK_LABEL (gtk_builder_get_object (builder, "label_message")));
	label_text = NULL;
	g_assert (label != NULL);
	g_assert (label_message != NULL);
	switch (self->priv->_mode) {
		case TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD:
		{
			char* _tmp2_;
			char* _tmp3_;
			label_text = (_tmp2_ = g_strdup (_ ("Username and password for %s")), _g_free0 (label_text), _tmp2_);
			gtk_label_set_text (label_message, _tmp3_ = g_strdup_printf (label_text, tuntun_connection_info_get_name (tuntun_connection_get_info (self->priv->_connection))));
			_g_free0 (_tmp3_);
			gtk_widget_show ((GtkWidget*) self->priv->_entry_user);
			gtk_widget_show ((GtkWidget*) label);
			break;
		}
		case TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY:
		{
			char* _tmp4_;
			char* _tmp5_;
			label_text = (_tmp4_ = g_strdup (_ ("Private key password for %s")), _g_free0 (label_text), _tmp4_);
			gtk_label_set_text (label_message, _tmp5_ = g_strdup_printf (label_text, tuntun_connection_info_get_name (tuntun_connection_get_info (self->priv->_connection))));
			_g_free0 (_tmp5_);
			gtk_widget_hide ((GtkWidget*) self->priv->_entry_user);
			gtk_widget_hide ((GtkWidget*) label);
			break;
		}
	}
	gtk_window_set_position ((GtkWindow*) self, GTK_WIN_POS_CENTER);
	_g_object_unref0 (builder);
	_g_object_unref0 (childs);
	_g_object_unref0 (button);
	_g_object_unref0 (label);
	_g_object_unref0 (label_message);
	_g_free0 (label_text);
}


static void tuntun_auth_dialog_on_button_ok_clicked (TuntunAuthDialog* self, GtkButton* sender) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	tuntun_auth_dialog_authenticate_dialog_finish (self, FALSE);
}


static void tuntun_auth_dialog_on_button_cancel_clicked (TuntunAuthDialog* self, GtkButton* sender) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	tuntun_auth_dialog_authenticate_dialog_finish (self, TRUE);
	gtk_object_destroy ((GtkObject*) self);
}


static void _tuntun_auth_dialog_on_item_delete_done_gnome_keyring_operation_done_callback (GnomeKeyringResult _result_, gpointer self) {
	tuntun_auth_dialog_on_item_delete_done (self, _result_);
}


static void tuntun_auth_dialog_on_connection_authentication_failed (TuntunAuthDialog* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (type != NULL);
	if (self->priv->_keyring_item_id != 0) {
		gnome_keyring_item_delete (NULL, (guint32) self->priv->_keyring_item_id, _tuntun_auth_dialog_on_item_delete_done_gnome_keyring_operation_done_callback, g_object_ref (self), g_object_unref);
	}
}


void tuntun_auth_dialog_authenticate (TuntunAuthDialog* self) {
	g_return_if_fail (self != NULL);
	self->priv->_current = TUNTUN_AUTH_STEPS_KEYRING;
	tuntun_auth_dialog_authenticate_keyring (self);
}


static void tuntun_auth_dialog_authenticate_keyring (TuntunAuthDialog* self) {
	g_return_if_fail (self != NULL);
	switch (self->priv->_mode) {
		case TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD:
		{
			tuntun_auth_dialog_authenticate_keyring_auth (self);
			break;
		}
		case TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY:
		{
			tuntun_auth_dialog_authenticate_keyring_private_key (self);
			break;
		}
	}
}


static void tuntun_auth_dialog_authenticate_dialog (TuntunAuthDialog* self) {
	g_return_if_fail (self != NULL);
	tuntun_auth_dialog_initialize_ui (self);
	self->priv->_current = TUNTUN_AUTH_STEPS_DIALOG;
	gtk_widget_show_all ((GtkWidget*) self);
}


static void tuntun_auth_dialog_authenticate_dialog_finish (TuntunAuthDialog* self, gboolean cancel) {
	char* username;
	char* password;
	g_return_if_fail (self != NULL);
	username = NULL;
	password = NULL;
	switch (self->priv->_mode) {
		case TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD:
		{
			char* _tmp0_;
			char* _tmp1_;
			username = (_tmp0_ = g_strdup (gtk_entry_get_text (self->priv->_entry_user)), _g_free0 (username), _tmp0_);
			password = (_tmp1_ = g_strdup (gtk_entry_get_text (self->priv->_entry_pass)), _g_free0 (password), _tmp1_);
			break;
		}
		case TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY:
		{
			char* _tmp2_;
			password = (_tmp2_ = g_strdup (gtk_entry_get_text (self->priv->_entry_pass)), _g_free0 (password), _tmp2_);
			break;
		}
	}
	if (!cancel) {
		tuntun_connection_authenticate (self->priv->_connection, self->priv->_type, username, password);
		if (gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->_checkbutton_save_in_keyring)) {
			if (username != NULL) {
				tuntun_auth_dialog_save (self, username, password);
			} else {
				tuntun_auth_dialog_save_private_key_password (self, password);
			}
		} else {
			gtk_object_destroy ((GtkObject*) self);
		}
	} else {
		tuntun_connection_cancel_authentication (self->priv->_connection, self->priv->_type, username);
	}
	_g_free0 (username);
	_g_free0 (password);
}


static void _tuntun_auth_dialog_on_find_password_done_gnome_keyring_operation_get_list_callback (GnomeKeyringResult _result_, GList* list, gpointer self) {
	tuntun_auth_dialog_on_find_password_done (self, _result_, list);
}


static void tuntun_auth_dialog_authenticate_keyring_auth (TuntunAuthDialog* self) {
	g_return_if_fail (self != NULL);
	gnome_keyring_find_network_password (NULL, NULL, tuntun_connection_info_get_address (tuntun_connection_get_info (self->priv->_connection)), NULL, "vpn", "auth", (guint32) 0, _tuntun_auth_dialog_on_find_password_done_gnome_keyring_operation_get_list_callback, g_object_ref (self), g_object_unref);
}


static void tuntun_auth_dialog_authenticate_keyring_private_key (TuntunAuthDialog* self) {
	g_return_if_fail (self != NULL);
	gnome_keyring_find_network_password (NULL, NULL, tuntun_connection_info_get_address (tuntun_connection_get_info (self->priv->_connection)), NULL, "vpn", "private-key", (guint32) 0, _tuntun_auth_dialog_on_find_password_done_gnome_keyring_operation_get_list_callback, g_object_ref (self), g_object_unref);
}


static void tuntun_auth_dialog_on_find_password_done (TuntunAuthDialog* self, GnomeKeyringResult _result_, GList* list) {
	char* username;
	char* password;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	username = NULL;
	password = NULL;
	if (_result_ == GNOME_KEYRING_RESULT_OK) {
		_tmp0_ = g_list_length (list) > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GnomeKeyringNetworkPasswordData* npd;
		npd = (GnomeKeyringNetworkPasswordData*) g_list_first (list)->data;
		self->priv->_keyring_item_id = (guint) npd->item_id;
		if (_vala_strcmp0 (npd->authtype, "auth") == 0) {
			char* _tmp1_;
			char* _tmp2_;
			username = (_tmp1_ = g_strdup (npd->user), _g_free0 (username), _tmp1_);
			password = (_tmp2_ = g_strdup (npd->password), _g_free0 (password), _tmp2_);
		} else {
			if (_vala_strcmp0 (npd->authtype, "private-key") == 0) {
				char* _tmp3_;
				char* _tmp4_;
				username = (_tmp3_ = NULL, _g_free0 (username), _tmp3_);
				password = (_tmp4_ = g_strdup (npd->password), _g_free0 (password), _tmp4_);
			}
		}
		tuntun_connection_authenticate (self->priv->_connection, self->priv->_type, username, password);
	} else {
		tuntun_auth_dialog_authenticate_dialog (self);
	}
	_g_free0 (username);
	_g_free0 (password);
}


static void tuntun_auth_dialog_on_item_delete_done (TuntunAuthDialog* self, GnomeKeyringResult _result_) {
	g_return_if_fail (self != NULL);
	if (_result_ != GNOME_KEYRING_RESULT_OK) {
		tuntun_utils_display_error (_ ("Keyring"), _ ("Error deleting credentials for '%s'"));
	}
}


static void tuntun_auth_dialog_on_set_password_done (TuntunAuthDialog* self, GnomeKeyringResult _result_, guint32 val) {
	g_return_if_fail (self != NULL);
	if (_result_ != GNOME_KEYRING_RESULT_OK) {
		tuntun_utils_display_error (_ ("Keyring"), _ ("Error saving credentials for '%s'"));
	}
	gtk_object_destroy ((GtkObject*) self);
}


static void _tuntun_auth_dialog_on_set_password_done_gnome_keyring_operation_get_int_callback (GnomeKeyringResult _result_, guint32 val, gpointer self) {
	tuntun_auth_dialog_on_set_password_done (self, _result_, val);
}


static void tuntun_auth_dialog_save (TuntunAuthDialog* self, const char* username, const char* password) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (username != NULL);
	g_return_if_fail (_vala_strcmp0 (username, "") != 0);
	gnome_keyring_set_network_password (NULL, username, NULL, tuntun_connection_info_get_address (tuntun_connection_get_info (self->priv->_connection)), NULL, "vpn", "auth", (guint32) 0, password, _tuntun_auth_dialog_on_set_password_done_gnome_keyring_operation_get_int_callback, g_object_ref (self), g_object_unref);
}


static void tuntun_auth_dialog_save_private_key_password (TuntunAuthDialog* self, const char* private_key_password) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (private_key_password != NULL);
	gnome_keyring_set_network_password (NULL, NULL, NULL, tuntun_connection_info_get_address (tuntun_connection_get_info (self->priv->_connection)), NULL, "vpn", "private-key", (guint32) 0, private_key_password, _tuntun_auth_dialog_on_set_password_done_gnome_keyring_operation_get_int_callback, g_object_ref (self), g_object_unref);
}


static void tuntun_auth_dialog_set_connection (TuntunAuthDialog* self, TuntunConnection* value) {
	TuntunConnection* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_connection = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_connection), _tmp0_);
	g_object_notify ((GObject *) self, "connection");
}


static void tuntun_auth_dialog_set_mode (TuntunAuthDialog* self, TuntunAuthenticationModes value) {
	g_return_if_fail (self != NULL);
	self->priv->_mode = value;
	g_object_notify ((GObject *) self, "mode");
}


static void tuntun_auth_dialog_set_type (TuntunAuthDialog* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_type = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_type), _tmp0_);
	g_object_notify ((GObject *) self, "type");
}


static void _tuntun_auth_dialog_on_connection_authentication_failed_tuntun_connection_authentication_failed (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self) {
	tuntun_auth_dialog_on_connection_authentication_failed (self, _sender, mode, type);
}


static GObject * tuntun_auth_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TuntunAuthDialog * self;
	parent_class = G_OBJECT_CLASS (tuntun_auth_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TUNTUN_AUTH_DIALOG (obj);
	{
		g_signal_connect_object (self->priv->_connection, "authentication-failed", (GCallback) _tuntun_auth_dialog_on_connection_authentication_failed_tuntun_connection_authentication_failed, self, 0);
	}
	return obj;
}


static void tuntun_auth_dialog_class_init (TuntunAuthDialogClass * klass) {
	tuntun_auth_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TuntunAuthDialogPrivate));
	G_OBJECT_CLASS (klass)->set_property = tuntun_auth_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuntun_auth_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuntun_auth_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_AUTH_DIALOG_CONNECTION, g_param_spec_object ("connection", "connection", "connection", TUNTUN_TYPE_CONNECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_AUTH_DIALOG_MODE, g_param_spec_enum ("mode", "mode", "mode", TUNTUN_TYPE_AUTHENTICATION_MODES, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_AUTH_DIALOG_TYPE, g_param_spec_string ("type", "type", "type", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void tuntun_auth_dialog_instance_init (TuntunAuthDialog * self) {
	self->priv = TUNTUN_AUTH_DIALOG_GET_PRIVATE (self);
	self->priv->_connection = NULL;
	self->priv->_mode = TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD;
	self->priv->_type = NULL;
	self->priv->_keyring_item_id = (guint) 0;
	self->priv->_current = TUNTUN_AUTH_STEPS_KEYRING;
}


static void tuntun_auth_dialog_finalize (GObject* obj) {
	TuntunAuthDialog * self;
	self = TUNTUN_AUTH_DIALOG (obj);
	_g_object_unref0 (self->priv->_connection);
	_g_free0 (self->priv->_type);
	G_OBJECT_CLASS (tuntun_auth_dialog_parent_class)->finalize (obj);
}


GType tuntun_auth_dialog_get_type (void) {
	static GType tuntun_auth_dialog_type_id = 0;
	if (tuntun_auth_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TuntunAuthDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuntun_auth_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TuntunAuthDialog), 0, (GInstanceInitFunc) tuntun_auth_dialog_instance_init, NULL };
		tuntun_auth_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "TuntunAuthDialog", &g_define_type_info, 0);
	}
	return tuntun_auth_dialog_type_id;
}


static void tuntun_auth_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TuntunAuthDialog * self;
	self = TUNTUN_AUTH_DIALOG (object);
	switch (property_id) {
		case TUNTUN_AUTH_DIALOG_CONNECTION:
		tuntun_auth_dialog_set_connection (self, g_value_get_object (value));
		break;
		case TUNTUN_AUTH_DIALOG_MODE:
		tuntun_auth_dialog_set_mode (self, g_value_get_enum (value));
		break;
		case TUNTUN_AUTH_DIALOG_TYPE:
		tuntun_auth_dialog_set_type (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




