/* tuntun-connection-dialog.c generated by valac, the Vala compiler
 * generated from tuntun-connection-dialog.vala, do not modify */

/*
 *  tuntun-connection-dialog.vala is a part of Tuntun
 *
 *  Tuntun: a simple applet to manage OpenVPN connections
 *
 *  Copyright (C) 2008  Andrea Del Signore
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 *  Author:
 *     Andrea Del Signore <sejerpz@tin.it>       
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define TUNTUN_TYPE_CONNECTION_DIALOG (tuntun_connection_dialog_get_type ())
#define TUNTUN_CONNECTION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION_DIALOG, TuntunConnectionDialog))
#define TUNTUN_CONNECTION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION_DIALOG, TuntunConnectionDialogClass))
#define TUNTUN_IS_CONNECTION_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION_DIALOG))
#define TUNTUN_IS_CONNECTION_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION_DIALOG))
#define TUNTUN_CONNECTION_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION_DIALOG, TuntunConnectionDialogClass))

typedef struct _TuntunConnectionDialog TuntunConnectionDialog;
typedef struct _TuntunConnectionDialogClass TuntunConnectionDialogClass;
typedef struct _TuntunConnectionDialogPrivate TuntunConnectionDialogPrivate;

#define TUNTUN_TYPE_CONNECTION_INFO (tuntun_connection_info_get_type ())
#define TUNTUN_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfo))
#define TUNTUN_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))
#define TUNTUN_IS_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_IS_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_CONNECTION_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))

typedef struct _TuntunConnectionInfo TuntunConnectionInfo;
typedef struct _TuntunConnectionInfoClass TuntunConnectionInfoClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TuntunConnectionDialog {
	GObject parent_instance;
	TuntunConnectionDialogPrivate * priv;
};

struct _TuntunConnectionDialogClass {
	GObjectClass parent_class;
};

struct _TuntunConnectionDialogPrivate {
	GtkDialog* _window;
	GtkEntry* _name;
	GtkEntry* _address;
	GtkEntry* _port;
	TuntunConnectionInfo* _connection_info;
};


static gpointer tuntun_connection_dialog_parent_class = NULL;

GType tuntun_connection_dialog_get_type (void);
GType tuntun_connection_info_get_type (void);
#define TUNTUN_CONNECTION_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TUNTUN_TYPE_CONNECTION_DIALOG, TuntunConnectionDialogPrivate))
enum  {
	TUNTUN_CONNECTION_DIALOG_DUMMY_PROPERTY,
	TUNTUN_CONNECTION_DIALOG_CONNECTION_INFO
};
GtkBuilder* tuntun_utils_get_ui (void);
static void tuntun_connection_dialog_on_button_connection_ok_clicked (TuntunConnectionDialog* self, GtkButton* sender);
static void _tuntun_connection_dialog_on_button_connection_ok_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void tuntun_connection_dialog_on_button_connection_cancel_clicked (TuntunConnectionDialog* self, GtkButton* sender);
static void _tuntun_connection_dialog_on_button_connection_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void tuntun_connection_dialog_update_text_entries (TuntunConnectionDialog* self);
static void tuntun_connection_dialog_initialize (TuntunConnectionDialog* self);
static void tuntun_connection_dialog_cleanup (TuntunConnectionDialog* self);
TuntunConnectionDialog* tuntun_connection_dialog_new (TuntunConnectionInfo* connection_info);
TuntunConnectionDialog* tuntun_connection_dialog_construct (GType object_type, TuntunConnectionInfo* connection_info);
GtkResponseType tuntun_connection_dialog_show (TuntunConnectionDialog* self, GtkWidget* parent);
static void tuntun_connection_dialog_update_connection_info_object (TuntunConnectionDialog* self);
static void tuntun_connection_dialog_set_text_if_null (TuntunConnectionDialog* self, GtkEntry* entry, const char* text);
const char* tuntun_connection_info_get_name (TuntunConnectionInfo* self);
const char* tuntun_connection_info_get_address (TuntunConnectionInfo* self);
gint tuntun_connection_info_get_port (TuntunConnectionInfo* self);
void tuntun_connection_info_set_name (TuntunConnectionInfo* self, const char* value);
void tuntun_connection_info_set_address (TuntunConnectionInfo* self, const char* value);
void tuntun_connection_info_set_port (TuntunConnectionInfo* self, gint value);
static void tuntun_connection_dialog_set_connection_info (TuntunConnectionDialog* self, TuntunConnectionInfo* value);
static GObject * tuntun_connection_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tuntun_connection_dialog_finalize (GObject* obj);
static void tuntun_connection_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _tuntun_connection_dialog_on_button_connection_ok_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	tuntun_connection_dialog_on_button_connection_ok_clicked (self, _sender);
}


static void _tuntun_connection_dialog_on_button_connection_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	tuntun_connection_dialog_on_button_connection_cancel_clicked (self, _sender);
}


static void tuntun_connection_dialog_initialize (TuntunConnectionDialog* self) {
	GtkBuilder* builder;
	GtkButton* button;
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	builder = _g_object_ref0 (tuntun_utils_get_ui ());
	self->priv->_window = GTK_DIALOG (gtk_builder_get_object (builder, "dialog_connection_properties"));
	g_assert (self->priv->_window != NULL);
	button = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_connection_dialog_ok")));
	g_assert (button != NULL);
	g_signal_connect_object (button, "clicked", (GCallback) _tuntun_connection_dialog_on_button_connection_ok_clicked_gtk_button_clicked, self, 0);
	button = (_tmp0_ = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_connection_dialog_cancel"))), _g_object_unref0 (button), _tmp0_);
	g_assert (button != NULL);
	g_signal_connect_object (button, "clicked", (GCallback) _tuntun_connection_dialog_on_button_connection_cancel_clicked_gtk_button_clicked, self, 0);
	self->priv->_name = GTK_ENTRY (gtk_builder_get_object (builder, "entry_connection_name"));
	g_assert (self->priv->_name != NULL);
	self->priv->_address = GTK_ENTRY (gtk_builder_get_object (builder, "entry_connection_host"));
	g_assert (self->priv->_address != NULL);
	self->priv->_port = GTK_ENTRY (gtk_builder_get_object (builder, "entry_connection_port"));
	g_assert (self->priv->_port != NULL);
	tuntun_connection_dialog_update_text_entries (self);
	_g_object_unref0 (builder);
	_g_object_unref0 (button);
}


static void tuntun_connection_dialog_cleanup (TuntunConnectionDialog* self) {
	GtkBuilder* builder;
	GtkButton* button;
	guint _tmp0_;
	GtkButton* _tmp1_;
	guint _tmp2_;
	g_return_if_fail (self != NULL);
	builder = _g_object_ref0 (tuntun_utils_get_ui ());
	button = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_connection_dialog_ok")));
	g_signal_handlers_disconnect_matched (button, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("clicked", GTK_TYPE_BUTTON, &_tmp0_, NULL, FALSE), _tmp0_), 0, NULL, (GCallback) _tuntun_connection_dialog_on_button_connection_ok_clicked_gtk_button_clicked, self);
	button = (_tmp1_ = _g_object_ref0 (GTK_BUTTON (gtk_builder_get_object (builder, "button_connection_dialog_cancel"))), _g_object_unref0 (button), _tmp1_);
	g_signal_handlers_disconnect_matched (button, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("clicked", GTK_TYPE_BUTTON, &_tmp2_, NULL, FALSE), _tmp2_), 0, NULL, (GCallback) _tuntun_connection_dialog_on_button_connection_cancel_clicked_gtk_button_clicked, self);
	_g_object_unref0 (builder);
	_g_object_unref0 (button);
}


TuntunConnectionDialog* tuntun_connection_dialog_construct (GType object_type, TuntunConnectionInfo* connection_info) {
	TuntunConnectionDialog * self;
	g_return_val_if_fail (connection_info != NULL, NULL);
	self = (TuntunConnectionDialog*) g_object_new (object_type, "connection-info", connection_info, NULL);
	return self;
}


TuntunConnectionDialog* tuntun_connection_dialog_new (TuntunConnectionInfo* connection_info) {
	return tuntun_connection_dialog_construct (TUNTUN_TYPE_CONNECTION_DIALOG, connection_info);
}


GtkResponseType tuntun_connection_dialog_show (TuntunConnectionDialog* self, GtkWidget* parent) {
	GtkResponseType result;
	GtkResponseType response;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (parent != NULL, 0);
	response = (GtkResponseType) gtk_dialog_run (self->priv->_window);
	tuntun_connection_dialog_cleanup (self);
	gtk_widget_hide ((GtkWidget*) self->priv->_window);
	result = response;
	return result;
}


static void tuntun_connection_dialog_on_button_connection_ok_clicked (TuntunConnectionDialog* self, GtkButton* sender) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	tuntun_connection_dialog_update_connection_info_object (self);
	gtk_dialog_response (self->priv->_window, (gint) GTK_RESPONSE_OK);
}


static void tuntun_connection_dialog_on_button_connection_cancel_clicked (TuntunConnectionDialog* self, GtkButton* sender) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	gtk_dialog_response (self->priv->_window, (gint) GTK_RESPONSE_CANCEL);
}


static void tuntun_connection_dialog_update_text_entries (TuntunConnectionDialog* self) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	tuntun_connection_dialog_set_text_if_null (self, self->priv->_name, tuntun_connection_info_get_name (self->priv->_connection_info));
	tuntun_connection_dialog_set_text_if_null (self, self->priv->_address, tuntun_connection_info_get_address (self->priv->_connection_info));
	tuntun_connection_dialog_set_text_if_null (self, self->priv->_port, _tmp0_ = g_strdup_printf ("%i", tuntun_connection_info_get_port (self->priv->_connection_info)));
	_g_free0 (_tmp0_);
}


static void tuntun_connection_dialog_update_connection_info_object (TuntunConnectionDialog* self) {
	g_return_if_fail (self != NULL);
	tuntun_connection_info_set_name (self->priv->_connection_info, gtk_entry_get_text (self->priv->_name));
	tuntun_connection_info_set_address (self->priv->_connection_info, gtk_entry_get_text (self->priv->_address));
	tuntun_connection_info_set_port (self->priv->_connection_info, atoi (gtk_entry_get_text (self->priv->_port)));
}


static void tuntun_connection_dialog_set_text_if_null (TuntunConnectionDialog* self, GtkEntry* entry, const char* text) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	g_return_if_fail (text != NULL);
	if (text != NULL) {
		gtk_entry_set_text (entry, text);
	} else {
		gtk_entry_set_text (entry, "");
	}
}


static void tuntun_connection_dialog_set_connection_info (TuntunConnectionDialog* self, TuntunConnectionInfo* value) {
	TuntunConnectionInfo* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_connection_info = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_connection_info), _tmp0_);
	g_object_notify ((GObject *) self, "connection-info");
}


static GObject * tuntun_connection_dialog_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TuntunConnectionDialog * self;
	parent_class = G_OBJECT_CLASS (tuntun_connection_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TUNTUN_CONNECTION_DIALOG (obj);
	{
		tuntun_connection_dialog_initialize (self);
	}
	return obj;
}


static void tuntun_connection_dialog_class_init (TuntunConnectionDialogClass * klass) {
	tuntun_connection_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TuntunConnectionDialogPrivate));
	G_OBJECT_CLASS (klass)->set_property = tuntun_connection_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuntun_connection_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuntun_connection_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_CONNECTION_DIALOG_CONNECTION_INFO, g_param_spec_object ("connection-info", "connection-info", "connection-info", TUNTUN_TYPE_CONNECTION_INFO, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("closed", TUNTUN_TYPE_CONNECTION_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void tuntun_connection_dialog_instance_init (TuntunConnectionDialog * self) {
	self->priv = TUNTUN_CONNECTION_DIALOG_GET_PRIVATE (self);
	self->priv->_window = NULL;
	self->priv->_name = NULL;
	self->priv->_address = NULL;
	self->priv->_port = NULL;
	self->priv->_connection_info = NULL;
}


static void tuntun_connection_dialog_finalize (GObject* obj) {
	TuntunConnectionDialog * self;
	self = TUNTUN_CONNECTION_DIALOG (obj);
	_g_object_unref0 (self->priv->_connection_info);
	G_OBJECT_CLASS (tuntun_connection_dialog_parent_class)->finalize (obj);
}


GType tuntun_connection_dialog_get_type (void) {
	static GType tuntun_connection_dialog_type_id = 0;
	if (tuntun_connection_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TuntunConnectionDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuntun_connection_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TuntunConnectionDialog), 0, (GInstanceInitFunc) tuntun_connection_dialog_instance_init, NULL };
		tuntun_connection_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "TuntunConnectionDialog", &g_define_type_info, 0);
	}
	return tuntun_connection_dialog_type_id;
}


static void tuntun_connection_dialog_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TuntunConnectionDialog * self;
	self = TUNTUN_CONNECTION_DIALOG (object);
	switch (property_id) {
		case TUNTUN_CONNECTION_DIALOG_CONNECTION_INFO:
		tuntun_connection_dialog_set_connection_info (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




