/* tuntun-connection.c generated by valac, the Vala compiler
 * generated from tuntun-connection.vala, do not modify */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TUNTUN_TYPE_CONNECTION_STATES (tuntun_connection_states_get_type ())

#define TUNTUN_TYPE_AUTHENTICATION_MODES (tuntun_authentication_modes_get_type ())

#define TUNTUN_TYPE_AUTHENTICATION_STEPS (tuntun_authentication_steps_get_type ())

#define TUNTUN_TYPE_CONNECTION (tuntun_connection_get_type ())
#define TUNTUN_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnection))
#define TUNTUN_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))
#define TUNTUN_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))

typedef struct _TuntunConnection TuntunConnection;
typedef struct _TuntunConnectionClass TuntunConnectionClass;
typedef struct _TuntunConnectionPrivate TuntunConnectionPrivate;

#define TUNTUN_TYPE_CONNECTION_INFO (tuntun_connection_info_get_type ())
#define TUNTUN_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfo))
#define TUNTUN_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))
#define TUNTUN_IS_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_IS_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_CONNECTION_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))

typedef struct _TuntunConnectionInfo TuntunConnectionInfo;
typedef struct _TuntunConnectionInfoClass TuntunConnectionInfoClass;

#define SNUL_TYPE_TCP_CLIENT (snul_tcp_client_get_type ())
#define SNUL_TCP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SNUL_TYPE_TCP_CLIENT, SnulTcpClient))
#define SNUL_TCP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SNUL_TYPE_TCP_CLIENT, SnulTcpClientClass))
#define SNUL_IS_TCP_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SNUL_TYPE_TCP_CLIENT))
#define SNUL_IS_TCP_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SNUL_TYPE_TCP_CLIENT))
#define SNUL_TCP_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SNUL_TYPE_TCP_CLIENT, SnulTcpClientClass))

typedef struct _SnulTcpClient SnulTcpClient;
typedef struct _SnulTcpClientClass SnulTcpClientClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	TUNTUN_CONNECTION_STATES_UNKNOWN = 0,
	TUNTUN_CONNECTION_STATES_ERROR = 1,
	TUNTUN_CONNECTION_STATES_CONNECTED = 2,
	TUNTUN_CONNECTION_STATES_CONNECTING = 3,
	TUNTUN_CONNECTION_STATES_DISCONNECTED = 4,
	TUNTUN_CONNECTION_STATES_DISCONNECTING = 5
} TuntunConnectionStates;

typedef enum  {
	TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY,
	TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD
} TuntunAuthenticationModes;

typedef enum  {
	TUNTUN_AUTHENTICATION_STEPS_NONE,
	TUNTUN_AUTHENTICATION_STEPS_USERNAME,
	TUNTUN_AUTHENTICATION_STEPS_PASSWORD
} TuntunAuthenticationSteps;

struct _TuntunConnection {
	GObject parent_instance;
	TuntunConnectionPrivate * priv;
};

struct _TuntunConnectionClass {
	GObjectClass parent_class;
};

struct _TuntunConnectionPrivate {
	TuntunConnectionInfo* _info;
	TuntunConnectionStates _status;
	TuntunConnectionStates _control_channel_status;
	SnulTcpClient* _client;
	gboolean _status_requested;
	gboolean _suspend_notifications;
	gboolean _suppress_auth_failed;
	char* _auth_type;
	char* _auth_username;
	char* _auth_password;
	TuntunAuthenticationSteps _auth_step;
};


static gpointer tuntun_connection_parent_class = NULL;

GType tuntun_connection_states_get_type (void);
GType tuntun_authentication_modes_get_type (void);
GType tuntun_authentication_steps_get_type (void);
GType tuntun_connection_get_type (void);
GType tuntun_connection_info_get_type (void);
GType snul_tcp_client_get_type (void);
#define TUNTUN_CONNECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TUNTUN_TYPE_CONNECTION, TuntunConnectionPrivate))
enum  {
	TUNTUN_CONNECTION_DUMMY_PROPERTY,
	TUNTUN_CONNECTION_INFO,
	TUNTUN_CONNECTION_CONTROL_CHANNEL_STATUS,
	TUNTUN_CONNECTION_STATUS
};
TuntunConnection* tuntun_connection_new (TuntunConnectionInfo* info);
TuntunConnection* tuntun_connection_construct (GType object_type, TuntunConnectionInfo* info);
static void tuntun_connection_notify (TuntunConnection* self, const char* property_name);
SnulTcpClient* snul_tcp_client_new (void);
SnulTcpClient* snul_tcp_client_construct (GType object_type);
static void tuntun_connection_client_connected (TuntunConnection* self, SnulTcpClient* sender, GSocketConnection* socket);
static void _tuntun_connection_client_connected_snul_tcp_client_connected (SnulTcpClient* _sender, GSocketConnection* socket, gpointer self);
static void tuntun_connection_client_data_received (TuntunConnection* self, SnulTcpClient* sender, const char* buffer, gsize len);
static void _tuntun_connection_client_data_received_snul_tcp_client_data_received (SnulTcpClient* _sender, const char* buffer, gsize len, gpointer self);
static void tuntun_connection_client_disconnected (TuntunConnection* self, SnulTcpClient* sender);
static void _tuntun_connection_client_disconnected_snul_tcp_client_disconnected (SnulTcpClient* _sender, gpointer self);
static void tuntun_connection_client_error (TuntunConnection* self, SnulTcpClient* sender, GError* _error_);
static void _tuntun_connection_client_error_snul_tcp_client_error (SnulTcpClient* _sender, GError* _error_, gpointer self);
static gboolean tuntun_connection_control_channel_connect (TuntunConnection* self);
gboolean tuntun_connection_initialize (TuntunConnection* self);
void tuntun_connection_set_control_channel_status (TuntunConnection* self, TuntunConnectionStates value);
void snul_tcp_client_connect (SnulTcpClient* self, const char* address, const char* port, GAsyncReadyCallback _callback_, gpointer _user_data_);
void snul_tcp_client_connect_finish (SnulTcpClient* self, GAsyncResult* _res_, GError** error);
const char* tuntun_connection_info_get_address (TuntunConnectionInfo* self);
gint tuntun_connection_info_get_port (TuntunConnectionInfo* self);
TuntunConnectionStates tuntun_connection_get_status (TuntunConnection* self);
void snul_tcp_client_disconnect (SnulTcpClient* self);
gboolean tuntun_connection_reinitialize (TuntunConnection* self);
gsize snul_tcp_client_send (SnulTcpClient* self, const char* buffer);
void tuntun_connection_set_status (TuntunConnection* self, TuntunConnectionStates value);
static char* tuntun_connection_extract_ip_address (TuntunConnection* self, const char* line);
void tuntun_connection_info_set_assigned_ip (TuntunConnectionInfo* self, const char* value);
static void tuntun_connection_authenticate_async (TuntunConnection* self);
void tuntun_connection_send (TuntunConnection* self, const char* data);
void tuntun_connection_connect (TuntunConnection* self);
void tuntun_connection_disconnect (TuntunConnection* self);
void tuntun_connection_authenticate (TuntunConnection* self, const char* type, const char* username, const char* password);
void tuntun_connection_cancel_authentication (TuntunConnection* self, const char* type, const char* username);
TuntunConnectionInfo* tuntun_connection_get_info (TuntunConnection* self);
static void tuntun_connection_set_info (TuntunConnection* self, TuntunConnectionInfo* value);
TuntunConnectionStates tuntun_connection_get_control_channel_status (TuntunConnection* self);
const char* tuntun_connection_info_get_assigned_ip (TuntunConnectionInfo* self);
static GObject * tuntun_connection_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tuntun_connection_finalize (GObject* obj);
static void tuntun_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void tuntun_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);


GType tuntun_connection_states_get_type (void) {
	static GType tuntun_connection_states_type_id = 0;
	if (G_UNLIKELY (tuntun_connection_states_type_id == 0)) {
		static const GEnumValue values[] = {{TUNTUN_CONNECTION_STATES_UNKNOWN, "TUNTUN_CONNECTION_STATES_UNKNOWN", "unknown"}, {TUNTUN_CONNECTION_STATES_ERROR, "TUNTUN_CONNECTION_STATES_ERROR", "error"}, {TUNTUN_CONNECTION_STATES_CONNECTED, "TUNTUN_CONNECTION_STATES_CONNECTED", "connected"}, {TUNTUN_CONNECTION_STATES_CONNECTING, "TUNTUN_CONNECTION_STATES_CONNECTING", "connecting"}, {TUNTUN_CONNECTION_STATES_DISCONNECTED, "TUNTUN_CONNECTION_STATES_DISCONNECTED", "disconnected"}, {TUNTUN_CONNECTION_STATES_DISCONNECTING, "TUNTUN_CONNECTION_STATES_DISCONNECTING", "disconnecting"}, {0, NULL, NULL}};
		tuntun_connection_states_type_id = g_enum_register_static ("TuntunConnectionStates", values);
	}
	return tuntun_connection_states_type_id;
}



GType tuntun_authentication_modes_get_type (void) {
	static GType tuntun_authentication_modes_type_id = 0;
	if (G_UNLIKELY (tuntun_authentication_modes_type_id == 0)) {
		static const GEnumValue values[] = {{TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY, "TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY", "password-only"}, {TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD, "TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD", "username-password"}, {0, NULL, NULL}};
		tuntun_authentication_modes_type_id = g_enum_register_static ("TuntunAuthenticationModes", values);
	}
	return tuntun_authentication_modes_type_id;
}



GType tuntun_authentication_steps_get_type (void) {
	static GType tuntun_authentication_steps_type_id = 0;
	if (G_UNLIKELY (tuntun_authentication_steps_type_id == 0)) {
		static const GEnumValue values[] = {{TUNTUN_AUTHENTICATION_STEPS_NONE, "TUNTUN_AUTHENTICATION_STEPS_NONE", "none"}, {TUNTUN_AUTHENTICATION_STEPS_USERNAME, "TUNTUN_AUTHENTICATION_STEPS_USERNAME", "username"}, {TUNTUN_AUTHENTICATION_STEPS_PASSWORD, "TUNTUN_AUTHENTICATION_STEPS_PASSWORD", "password"}, {0, NULL, NULL}};
		tuntun_authentication_steps_type_id = g_enum_register_static ("TuntunAuthenticationSteps", values);
	}
	return tuntun_authentication_steps_type_id;
}


TuntunConnection* tuntun_connection_construct (GType object_type, TuntunConnectionInfo* info) {
	TuntunConnection * self;
	g_return_val_if_fail (info != NULL, NULL);
	self = (TuntunConnection*) g_object_new (object_type, "info", info, NULL);
	return self;
}


TuntunConnection* tuntun_connection_new (TuntunConnectionInfo* info) {
	return tuntun_connection_construct (TUNTUN_TYPE_CONNECTION, info);
}


static void tuntun_connection_notify (TuntunConnection* self, const char* property_name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (property_name != NULL);
	g_object_notify ((GObject*) self, property_name);
}


static void _tuntun_connection_client_connected_snul_tcp_client_connected (SnulTcpClient* _sender, GSocketConnection* socket, gpointer self) {
	tuntun_connection_client_connected (self, _sender, socket);
}


static void _tuntun_connection_client_data_received_snul_tcp_client_data_received (SnulTcpClient* _sender, const char* buffer, gsize len, gpointer self) {
	tuntun_connection_client_data_received (self, _sender, buffer, len);
}


static void _tuntun_connection_client_disconnected_snul_tcp_client_disconnected (SnulTcpClient* _sender, gpointer self) {
	tuntun_connection_client_disconnected (self, _sender);
}


static void _tuntun_connection_client_error_snul_tcp_client_error (SnulTcpClient* _sender, GError* _error_, gpointer self) {
	tuntun_connection_client_error (self, _sender, _error_);
}


gboolean tuntun_connection_initialize (TuntunConnection* self) {
	gboolean result;
	SnulTcpClient* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->_client = (_tmp0_ = snul_tcp_client_new (), _g_object_unref0 (self->priv->_client), _tmp0_);
	g_signal_connect_object (self->priv->_client, "connected", (GCallback) _tuntun_connection_client_connected_snul_tcp_client_connected, self, 0);
	g_signal_connect_object (self->priv->_client, "data-received", (GCallback) _tuntun_connection_client_data_received_snul_tcp_client_data_received, self, 0);
	g_signal_connect_object (self->priv->_client, "disconnected", (GCallback) _tuntun_connection_client_disconnected_snul_tcp_client_disconnected, self, 0);
	g_signal_connect_object (self->priv->_client, "error", (GCallback) _tuntun_connection_client_error_snul_tcp_client_error, self, 0);
	result = tuntun_connection_control_channel_connect (self);
	return result;
}


static gboolean tuntun_connection_control_channel_connect (TuntunConnection* self) {
	gboolean result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, FALSE);
	_inner_error_ = NULL;
	self->priv->_suspend_notifications = TRUE;
	self->priv->_status_requested = FALSE;
	{
		char* _tmp0_;
		tuntun_connection_set_control_channel_status (self, TUNTUN_CONNECTION_STATES_CONNECTING);
		snul_tcp_client_connect (self->priv->_client, tuntun_connection_info_get_address (self->priv->_info), _tmp0_ = g_strdup_printf ("%i", tuntun_connection_info_get_port (self->priv->_info)), NULL, NULL);
		_g_free0 (_tmp0_);
		result = TRUE;
		return result;
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("tuntun-connection.vala:125: Error initializiong connection %s", err->message);
			tuntun_connection_set_control_channel_status (self, TUNTUN_CONNECTION_STATES_ERROR);
			result = FALSE;
			_g_error_free0 (err);
			return result;
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
}


gboolean tuntun_connection_reinitialize (TuntunConnection* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (tuntun_connection_get_status (self) == TUNTUN_CONNECTION_STATES_CONNECTED) {
		snul_tcp_client_disconnect (self->priv->_client);
	}
	result = tuntun_connection_initialize (self);
	return result;
}


static void tuntun_connection_client_connected (TuntunConnection* self, SnulTcpClient* sender, GSocketConnection* socket) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (socket != NULL);
	tuntun_connection_set_control_channel_status (self, TUNTUN_CONNECTION_STATES_CONNECTED);
	snul_tcp_client_send (self->priv->_client, "state on\n");
	if (self->priv->_control_channel_status != TUNTUN_CONNECTION_STATES_ERROR) {
		self->priv->_status_requested = TRUE;
		snul_tcp_client_send (self->priv->_client, "state\n");
	}
}


static void tuntun_connection_client_disconnected (TuntunConnection* self, SnulTcpClient* sender) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	if (tuntun_connection_get_status (self) != TUNTUN_CONNECTION_STATES_ERROR) {
		tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_UNKNOWN);
	}
}


static void tuntun_connection_client_error (TuntunConnection* self, SnulTcpClient* sender, GError* _error_) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	self->priv->_suspend_notifications = FALSE;
	snul_tcp_client_disconnect (sender);
	tuntun_connection_set_control_channel_status (self, TUNTUN_CONNECTION_STATES_ERROR);
	self->priv->_status_requested = FALSE;
}


static void tuntun_connection_client_data_received (TuntunConnection* self, SnulTcpClient* sender, const char* buffer, gsize len) {
	char** _tmp1_;
	gint lines_size;
	gint lines_length1;
	char** _tmp0_;
	char** lines;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (buffer != NULL);
	lines = (_tmp1_ = _tmp0_ = g_strsplit (buffer, "\n", 0), lines_length1 = _vala_array_length (_tmp0_), lines_size = lines_length1, _tmp1_);
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
		line_collection = lines;
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			char* line;
			line = g_strdup (line_collection[line_it]);
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				if (_vala_strcmp0 (line, "") == 0) {
					_tmp2_ = TRUE;
				} else {
					_tmp2_ = _vala_strcmp0 (line, "\n") == 0;
				}
				if (_tmp2_) {
					_g_free0 (line);
					continue;
				}
				if (self->priv->_status_requested) {
					_tmp3_ = g_pattern_match_simple ("*,CONNECTED,SUCCESS,*", line);
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					char* _tmp4_;
					tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_CONNECTED);
					tuntun_connection_info_set_assigned_ip (self->priv->_info, _tmp4_ = tuntun_connection_extract_ip_address (self, line));
					_g_free0 (_tmp4_);
					self->priv->_status_requested = FALSE;
					self->priv->_suspend_notifications = FALSE;
				} else {
					gboolean _tmp5_ = FALSE;
					if (self->priv->_status_requested) {
						gboolean _tmp6_ = FALSE;
						if (g_pattern_match_simple ("*,RECONNECTING,*", line)) {
							_tmp6_ = TRUE;
						} else {
							_tmp6_ = g_pattern_match_simple ("*,CONNECTING,*", line);
						}
						_tmp5_ = _tmp6_;
					} else {
						_tmp5_ = FALSE;
					}
					if (_tmp5_) {
						tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_DISCONNECTED);
						self->priv->_status_requested = FALSE;
						self->priv->_suspend_notifications = FALSE;
					} else {
						if (g_pattern_match_simple (">STATE:*,CONNECTED,SUCCESS,*", line)) {
							tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_CONNECTED);
						} else {
							gboolean _tmp7_ = FALSE;
							if (g_pattern_match_simple (">STATE:*,RECONNECTING,*error*", line)) {
								_tmp7_ = TRUE;
							} else {
								_tmp7_ = g_pattern_match_simple (">STATE:*,RECONNECTING,SIGHUP*", line);
							}
							if (_tmp7_) {
								tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_DISCONNECTED);
							} else {
								gboolean _tmp8_ = FALSE;
								if (g_pattern_match_simple (">STATE:*,RECONNECTING,auth-failure*", line)) {
									_tmp8_ = TRUE;
								} else {
									_tmp8_ = g_pattern_match_simple (">STATE:*,RECONNECTING,private-key-password-failure*", line);
								}
								if (_tmp8_) {
									self->priv->_status = TUNTUN_CONNECTION_STATES_DISCONNECTED;
								} else {
									if (g_pattern_match_simple (">STATE:*,WAIT", line)) {
										tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_CONNECTING);
									} else {
										if (g_pattern_match_simple (">PASSWORD*'Auth'*username/password*", line)) {
											g_signal_emit_by_name (self, "authentication-required", TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD, "Auth");
										} else {
											if (g_pattern_match_simple (">PASSWORD*'Private Key'*password*", line)) {
												g_signal_emit_by_name (self, "authentication-required", TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY, "Private Key");
											} else {
												gboolean _tmp9_ = FALSE;
												if (self->priv->_auth_step != TUNTUN_AUTHENTICATION_STEPS_NONE) {
													gboolean _tmp10_ = FALSE;
													char* _tmp11_;
													gboolean _tmp12_;
													if ((_tmp12_ = g_pattern_match_simple (_tmp11_ = g_strdup_printf ("SUCCESS: '%s'*username*", self->priv->_auth_type), line), _g_free0 (_tmp11_), _tmp12_)) {
														_tmp10_ = TRUE;
													} else {
														char* _tmp13_;
														_tmp10_ = g_pattern_match_simple (_tmp13_ = g_strdup_printf ("SUCCESS: '%s'*password*", self->priv->_auth_type), line);
														_g_free0 (_tmp13_);
													}
													_tmp9_ = _tmp10_;
												} else {
													_tmp9_ = FALSE;
												}
												if (_tmp9_) {
													tuntun_connection_authenticate_async (self);
												} else {
													if (g_pattern_match_simple ("*PASSWORD*Verification*Failed*'Auth'*", line)) {
														if (!self->priv->_suppress_auth_failed) {
															g_signal_emit_by_name (self, "authentication-failed", TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD, "Auth");
														}
													} else {
														if (g_pattern_match_simple ("*PASSWORD*Verification*Failed*'Private Key'*", line)) {
															if (!self->priv->_suppress_auth_failed) {
																g_signal_emit_by_name (self, "authentication-failed", TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY, "Private Key");
															}
														} else {
															if (g_pattern_match_simple ("*FATAL*ERROR*", line)) {
																g_signal_emit_by_name (self, "control-channel-fatal-error", line);
															} else {
																if (g_pattern_match_simple (">STATE:*,ASSIGN_IP,*", line)) {
																	char* _tmp14_;
																	tuntun_connection_info_set_assigned_ip (self->priv->_info, _tmp14_ = tuntun_connection_extract_ip_address (self, line));
																	_g_free0 (_tmp14_);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
				g_signal_emit_by_name (self, "control-channel-data-received", line);
				_g_free0 (line);
			}
		}
	}
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


static char* tuntun_connection_extract_ip_address (TuntunConnection* self, const char* line) {
	char* result;
	char** _tmp1_;
	gint toks_size;
	gint toks_length1;
	char** _tmp0_;
	char** toks;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (line != NULL, NULL);
	toks = (_tmp1_ = _tmp0_ = g_strsplit (line, ",", 5), toks_length1 = _vala_array_length (_tmp0_), toks_size = toks_length1, _tmp1_);
	if (toks[3] != NULL) {
		result = g_strdup (toks[3]);
		toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		result = g_strdup (_ ("unknown"));
		toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	toks = (_vala_array_free (toks, toks_length1, (GDestroyNotify) g_free), NULL);
}


void tuntun_connection_send (TuntunConnection* self, const char* data) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (data != NULL);
	snul_tcp_client_send (self->priv->_client, data);
	if (g_pattern_match_simple ("password \"*\"*", data)) {
		g_signal_emit_by_name (self, "control-channel-data-sent", "password ******** sent");
	} else {
		g_signal_emit_by_name (self, "control-channel-data-sent", data);
	}
}


void tuntun_connection_connect (TuntunConnection* self) {
	g_return_if_fail (self != NULL);
	tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_CONNECTING);
	snul_tcp_client_send (self->priv->_client, "hold release\n");
}


void tuntun_connection_disconnect (TuntunConnection* self) {
	g_return_if_fail (self != NULL);
	tuntun_connection_set_status (self, TUNTUN_CONNECTION_STATES_DISCONNECTING);
	snul_tcp_client_send (self->priv->_client, "signal SIGHUP\n");
}


void tuntun_connection_authenticate (TuntunConnection* self, const char* type, const char* username, const char* password) {
	gboolean _tmp0_ = FALSE;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	if (username != NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = password != NULL;
	}
	g_return_if_fail (_tmp0_);
	self->priv->_auth_type = (_tmp1_ = g_strdup (type), _g_free0 (self->priv->_auth_type), _tmp1_);
	self->priv->_auth_username = (_tmp2_ = g_strdup (username), _g_free0 (self->priv->_auth_username), _tmp2_);
	self->priv->_auth_password = (_tmp3_ = g_strdup (password), _g_free0 (self->priv->_auth_password), _tmp3_);
	if (username == NULL) {
		self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_USERNAME;
	} else {
		self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_NONE;
	}
	tuntun_connection_authenticate_async (self);
}


static void tuntun_connection_authenticate_async (TuntunConnection* self) {
	char* data;
	g_return_if_fail (self != NULL);
	data = NULL;
	switch (self->priv->_auth_step) {
		case TUNTUN_AUTHENTICATION_STEPS_NONE:
		{
			if (self->priv->_auth_username != NULL) {
				char* _tmp0_;
				self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_USERNAME;
				data = (_tmp0_ = g_strdup_printf ("username \"%s\" \"%s\"\n", self->priv->_auth_type, self->priv->_auth_username), _g_free0 (data), _tmp0_);
				tuntun_connection_send (self, data);
			}
			break;
		}
		case TUNTUN_AUTHENTICATION_STEPS_USERNAME:
		{
			if (self->priv->_auth_password != NULL) {
				char* _tmp1_;
				self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_PASSWORD;
				data = (_tmp1_ = g_strdup_printf ("password \"%s\" \"%s\"\n", self->priv->_auth_type, self->priv->_auth_password), _g_free0 (data), _tmp1_);
				tuntun_connection_send (self, data);
			}
			break;
		}
		default:
		{
			self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_NONE;
			break;
		}
	}
	_g_free0 (data);
}


void tuntun_connection_cancel_authentication (TuntunConnection* self, const char* type, const char* username) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (username != NULL);
	self->priv->_suppress_auth_failed = TRUE;
	if (username != NULL) {
		username = "*";
	}
	tuntun_connection_authenticate (self, type, username, "*");
}


TuntunConnectionInfo* tuntun_connection_get_info (TuntunConnection* self) {
	TuntunConnectionInfo* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_info;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void tuntun_connection_set_info (TuntunConnection* self, TuntunConnectionInfo* value) {
	TuntunConnectionInfo* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_info = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_info), _tmp0_);
	g_object_notify ((GObject *) self, "info");
}


TuntunConnectionStates tuntun_connection_get_control_channel_status (TuntunConnection* self) {
	TuntunConnectionStates result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_control_channel_status;
	return result;
}


void tuntun_connection_set_control_channel_status (TuntunConnection* self, TuntunConnectionStates value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_control_channel_status != value) {
		self->priv->_control_channel_status = value;
		if (!self->priv->_suspend_notifications) {
			tuntun_connection_notify (self, "control-channel-status");
		}
	}
	g_object_notify ((GObject *) self, "control-channel-status");
}


TuntunConnectionStates tuntun_connection_get_status (TuntunConnection* self) {
	TuntunConnectionStates result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_status;
	return result;
}


void tuntun_connection_set_status (TuntunConnection* self, TuntunConnectionStates value) {
	g_return_if_fail (self != NULL);
	if (self->priv->_status != value) {
		gboolean _tmp0_ = FALSE;
		self->priv->_status = value;
		if (self->priv->_status != TUNTUN_CONNECTION_STATES_CONNECTED) {
			_tmp0_ = _vala_strcmp0 (tuntun_connection_info_get_assigned_ip (self->priv->_info), _ ("none")) != 0;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			tuntun_connection_info_set_assigned_ip (self->priv->_info, _ ("none"));
		}
		if (!self->priv->_suspend_notifications) {
			tuntun_connection_notify (self, "status");
		}
	}
	g_object_notify ((GObject *) self, "status");
}


static GObject * tuntun_connection_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TuntunConnection * self;
	parent_class = G_OBJECT_CLASS (tuntun_connection_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TUNTUN_CONNECTION (obj);
	{
		self->priv->_status = TUNTUN_CONNECTION_STATES_UNKNOWN;
	}
	return obj;
}


static void tuntun_connection_class_init (TuntunConnectionClass * klass) {
	tuntun_connection_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TuntunConnectionPrivate));
	G_OBJECT_CLASS (klass)->get_property = tuntun_connection_get_property;
	G_OBJECT_CLASS (klass)->set_property = tuntun_connection_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuntun_connection_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuntun_connection_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_CONNECTION_INFO, g_param_spec_object ("info", "info", "info", TUNTUN_TYPE_CONNECTION_INFO, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_CONNECTION_CONTROL_CHANNEL_STATUS, g_param_spec_enum ("control-channel-status", "control-channel-status", "control-channel-status", TUNTUN_TYPE_CONNECTION_STATES, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNTUN_CONNECTION_STATUS, g_param_spec_enum ("status", "status", "status", TUNTUN_TYPE_CONNECTION_STATES, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("control_channel_data_received", TUNTUN_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("control_channel_data_sent", TUNTUN_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("control_channel_fatal_error", TUNTUN_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("authentication_required", TUNTUN_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, TUNTUN_TYPE_AUTHENTICATION_MODES, G_TYPE_STRING);
	g_signal_new ("authentication_failed", TUNTUN_TYPE_CONNECTION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, TUNTUN_TYPE_AUTHENTICATION_MODES, G_TYPE_STRING);
}


static void tuntun_connection_instance_init (TuntunConnection * self) {
	self->priv = TUNTUN_CONNECTION_GET_PRIVATE (self);
	self->priv->_status_requested = FALSE;
	self->priv->_suspend_notifications = FALSE;
	self->priv->_suppress_auth_failed = FALSE;
	self->priv->_auth_type = NULL;
	self->priv->_auth_username = NULL;
	self->priv->_auth_password = NULL;
	self->priv->_auth_step = TUNTUN_AUTHENTICATION_STEPS_NONE;
}


static void tuntun_connection_finalize (GObject* obj) {
	TuntunConnection * self;
	self = TUNTUN_CONNECTION (obj);
	_g_object_unref0 (self->priv->_info);
	_g_object_unref0 (self->priv->_client);
	_g_free0 (self->priv->_auth_type);
	_g_free0 (self->priv->_auth_username);
	_g_free0 (self->priv->_auth_password);
	G_OBJECT_CLASS (tuntun_connection_parent_class)->finalize (obj);
}


GType tuntun_connection_get_type (void) {
	static GType tuntun_connection_type_id = 0;
	if (tuntun_connection_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TuntunConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuntun_connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TuntunConnection), 0, (GInstanceInitFunc) tuntun_connection_instance_init, NULL };
		tuntun_connection_type_id = g_type_register_static (G_TYPE_OBJECT, "TuntunConnection", &g_define_type_info, 0);
	}
	return tuntun_connection_type_id;
}


static void tuntun_connection_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TuntunConnection * self;
	self = TUNTUN_CONNECTION (object);
	switch (property_id) {
		case TUNTUN_CONNECTION_INFO:
		g_value_set_object (value, tuntun_connection_get_info (self));
		break;
		case TUNTUN_CONNECTION_CONTROL_CHANNEL_STATUS:
		g_value_set_enum (value, tuntun_connection_get_control_channel_status (self));
		break;
		case TUNTUN_CONNECTION_STATUS:
		g_value_set_enum (value, tuntun_connection_get_status (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void tuntun_connection_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TuntunConnection * self;
	self = TUNTUN_CONNECTION (object);
	switch (property_id) {
		case TUNTUN_CONNECTION_INFO:
		tuntun_connection_set_info (self, g_value_get_object (value));
		break;
		case TUNTUN_CONNECTION_CONTROL_CHANNEL_STATUS:
		tuntun_connection_set_control_channel_status (self, g_value_get_enum (value));
		break;
		case TUNTUN_CONNECTION_STATUS:
		tuntun_connection_set_status (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), data2);
}



