/* tuntun-connections.c generated by valac, the Vala compiler
 * generated from tuntun-connections.vala, do not modify */

/*
 *  tuntun-connections.vala is a part of Tuntun
 *
 *  Tuntun: a simple applet to manage OpenVPN connections
 *
 *  Copyright (C) 2008  Andrea Del Signore
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 *  Author:
 *     Andrea Del Signore <sejerpz@tin.it>       
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>


#define TUNTUN_TYPE_CONNECTIONS (tuntun_connections_get_type ())
#define TUNTUN_CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTIONS, TuntunConnections))
#define TUNTUN_CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTIONS, TuntunConnectionsClass))
#define TUNTUN_IS_CONNECTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTIONS))
#define TUNTUN_IS_CONNECTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTIONS))
#define TUNTUN_CONNECTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTIONS, TuntunConnectionsClass))

typedef struct _TuntunConnections TuntunConnections;
typedef struct _TuntunConnectionsClass TuntunConnectionsClass;
typedef struct _TuntunConnectionsPrivate TuntunConnectionsPrivate;

#define TUNTUN_TYPE_CONNECTION (tuntun_connection_get_type ())
#define TUNTUN_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnection))
#define TUNTUN_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))
#define TUNTUN_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION))
#define TUNTUN_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION, TuntunConnectionClass))

typedef struct _TuntunConnection TuntunConnection;
typedef struct _TuntunConnectionClass TuntunConnectionClass;

#define TUNTUN_TYPE_AUTHENTICATION_MODES (tuntun_authentication_modes_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_markup_parse_context_free0(var) ((var == NULL) ? NULL : (var = (g_markup_parse_context_free (var), NULL)))

#define TUNTUN_TYPE_CONNECTION_INFO (tuntun_connection_info_get_type ())
#define TUNTUN_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfo))
#define TUNTUN_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))
#define TUNTUN_IS_CONNECTION_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_IS_CONNECTION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_CONNECTION_INFO))
#define TUNTUN_CONNECTION_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_CONNECTION_INFO, TuntunConnectionInfoClass))

typedef struct _TuntunConnectionInfo TuntunConnectionInfo;
typedef struct _TuntunConnectionInfoClass TuntunConnectionInfoClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNTUN_TYPE_CONNECTION_STATES (tuntun_connection_states_get_type ())

typedef enum  {
	TUNTUN_AUTHENTICATION_MODES_PASSWORD_ONLY,
	TUNTUN_AUTHENTICATION_MODES_USERNAME_PASSWORD
} TuntunAuthenticationModes;

struct _TuntunConnections {
	GObject parent_instance;
	TuntunConnectionsPrivate * priv;
	GList* items;
};

struct _TuntunConnectionsClass {
	GObjectClass parent_class;
	void (*on_connection_activity) (TuntunConnections* self, TuntunConnection* connection);
	void (*on_connection_fatal_error) (TuntunConnections* self, TuntunConnection* connection, const char* _error_);
	void (*on_connection_authentication_required) (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
	void (*on_connection_authentication_failed) (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
	void (*on_connection_removed) (TuntunConnections* self, TuntunConnection* connection);
	void (*on_connection_added) (TuntunConnections* self, TuntunConnection* connection);
	void (*on_connection_status_changed) (TuntunConnections* self, TuntunConnection* connection);
};

struct _TuntunConnectionsPrivate {
	char* _config_file;
	guint _timeout_id;
};

typedef enum  {
	TUNTUN_CONNECTION_STATES_UNKNOWN = 0,
	TUNTUN_CONNECTION_STATES_ERROR = 1,
	TUNTUN_CONNECTION_STATES_CONNECTED = 2,
	TUNTUN_CONNECTION_STATES_CONNECTING = 3,
	TUNTUN_CONNECTION_STATES_DISCONNECTED = 4,
	TUNTUN_CONNECTION_STATES_DISCONNECTING = 5
} TuntunConnectionStates;


static gpointer tuntun_connections_parent_class = NULL;

GType tuntun_connections_get_type (void);
GType tuntun_connection_get_type (void);
GType tuntun_authentication_modes_get_type (void);
#define TUNTUN_CONNECTIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TUNTUN_TYPE_CONNECTIONS, TuntunConnectionsPrivate))
enum  {
	TUNTUN_CONNECTIONS_DUMMY_PROPERTY
};
static void _g_list_free_g_object_unref (GList* self);
char* tuntun_utils_gnome_util_home_file (const char* afile);
#define TUNTUN_CONSTANTS_CONNECTIONS_FILENAME "tuntun.xml"
static void tuntun_connections_load_config (TuntunConnections* self, const char* filename, GError** error);
static void tuntun_connections_load (TuntunConnections* self);
static void tuntun_connections_xmlconfig_start_element_handler (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, void* user_data, GError** error);
static void tuntun_connections_save_config (TuntunConnections* self, const char* filename, GError** error);
void tuntun_connections_save (TuntunConnections* self, GError** error);
GType tuntun_connection_info_get_type (void);
TuntunConnectionInfo* tuntun_connection_get_info (TuntunConnection* self);
gboolean tuntun_connection_info_get_quick_connect (TuntunConnectionInfo* self);
const char* tuntun_connection_info_get_name (TuntunConnectionInfo* self);
const char* tuntun_connection_info_get_address (TuntunConnectionInfo* self);
gint tuntun_connection_info_get_port (TuntunConnectionInfo* self);
TuntunConnectionInfo* tuntun_connection_info_new (void);
TuntunConnectionInfo* tuntun_connection_info_construct (GType object_type);
void tuntun_connection_info_set_name (TuntunConnectionInfo* self, const char* value);
void tuntun_connection_info_set_address (TuntunConnectionInfo* self, const char* value);
void tuntun_connection_info_set_port (TuntunConnectionInfo* self, gint value);
void tuntun_connection_info_set_quick_connect (TuntunConnectionInfo* self, gboolean value);
TuntunConnection* tuntun_connection_new (TuntunConnectionInfo* info);
TuntunConnection* tuntun_connection_construct (GType object_type, TuntunConnectionInfo* info);
void tuntun_connections_add (TuntunConnections* self, TuntunConnection* connection);
gboolean tuntun_connection_initialize (TuntunConnection* self);
void tuntun_connections_on_connection_added (TuntunConnections* self, TuntunConnection* connection);
static void tuntun_connections_connection_notify_property_changed (TuntunConnection* connection, GParamSpec* param, TuntunConnections* connections);
void tuntun_connections_on_connection_authentication_required (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
static void _tuntun_connections_on_connection_authentication_required_tuntun_connection_authentication_required (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self);
void tuntun_connections_on_connection_authentication_failed (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
static void _tuntun_connections_on_connection_authentication_failed_tuntun_connection_authentication_failed (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self);
void tuntun_connections_on_connection_fatal_error (TuntunConnections* self, TuntunConnection* connection, const char* _error_);
static void _tuntun_connections_on_connection_fatal_error_tuntun_connection_control_channel_fatal_error (TuntunConnection* _sender, const char* _error_, gpointer self);
static void tuntun_connections_on_connection_data_received (TuntunConnections* self, TuntunConnection* connection, const char* data);
static void _tuntun_connections_on_connection_data_received_tuntun_connection_control_channel_data_received (TuntunConnection* _sender, const char* data, gpointer self);
void tuntun_connections_on_connection_removed (TuntunConnections* self, TuntunConnection* connection);
void tuntun_connections_remove (TuntunConnections* self, TuntunConnection* connection);
void tuntun_connections_on_connection_activity (TuntunConnections* self, TuntunConnection* connection);
static void tuntun_connections_real_on_connection_activity (TuntunConnections* self, TuntunConnection* connection);
static void tuntun_connections_real_on_connection_fatal_error (TuntunConnections* self, TuntunConnection* connection, const char* _error_);
static void tuntun_connections_real_on_connection_authentication_required (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
static void tuntun_connections_real_on_connection_authentication_failed (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type);
static void tuntun_connections_real_on_connection_removed (TuntunConnections* self, TuntunConnection* connection);
static void tuntun_connections_real_on_connection_added (TuntunConnections* self, TuntunConnection* connection);
GType tuntun_connection_states_get_type (void);
TuntunConnectionStates tuntun_connection_get_control_channel_status (TuntunConnection* self);
static gboolean tuntun_connections_connection_recheck (TuntunConnections* self);
static gboolean _tuntun_connections_connection_recheck_gsource_func (gpointer self);
void tuntun_connections_on_connection_status_changed (TuntunConnections* self, TuntunConnection* connection);
static void tuntun_connections_real_on_connection_status_changed (TuntunConnections* self, TuntunConnection* connection);
gboolean tuntun_connection_reinitialize (TuntunConnection* self);
TuntunConnections* tuntun_connections_new (void);
TuntunConnections* tuntun_connections_construct (GType object_type);
static GObject * tuntun_connections_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void tuntun_connections_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);


static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static void tuntun_connections_load (TuntunConnections* self) {
	GError * _inner_error_;
	char* _old_config_file;
	char* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	_old_config_file = tuntun_utils_gnome_util_home_file (TUNTUN_CONSTANTS_CONNECTIONS_FILENAME);
	self->priv->_config_file = (_tmp0_ = g_build_filename (g_get_user_config_dir (), TUNTUN_CONSTANTS_CONNECTIONS_FILENAME, NULL), _g_free0 (self->priv->_config_file), _tmp0_);
	if (_vala_strcmp0 (_old_config_file, self->priv->_config_file) != 0) {
		_tmp3_ = g_file_test (_old_config_file, G_FILE_TEST_IS_REGULAR);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = !g_file_test (_old_config_file, G_FILE_TEST_IS_SYMLINK);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = !g_file_test (self->priv->_config_file, G_FILE_TEST_IS_REGULAR);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		g_print ("migrating config from %s to %s\n", _old_config_file, self->priv->_config_file);
		g_rename (_old_config_file, self->priv->_config_file);
	}
	{
		tuntun_connections_load_config (self, self->priv->_config_file, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch3_g_error;
			goto __finally3;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("tuntun-connections.vala:69: Error reading config file: %s, %s", self->priv->_config_file, err->message);
			_g_error_free0 (err);
		}
	}
	__finally3:
	if (_inner_error_ != NULL) {
		_g_free0 (_old_config_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (_old_config_file);
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static void tuntun_connections_load_config (TuntunConnections* self, const char* filename, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	{
		GMarkupParser _tmp0_ = {0};
		GMarkupParser parser;
		char* content;
		gsize len = 0UL;
		gboolean _tmp1_ = FALSE;
		char* _tmp4_;
		gboolean _tmp3_;
		char* _tmp2_ = NULL;
		GMarkupParseContext* context;
		parser = (memset (&_tmp0_, 0, sizeof (GMarkupParser)), _tmp0_);
		content = NULL;
		if (!g_file_test (filename, G_FILE_TEST_EXISTS)) {
			_g_free0 (content);
			return;
		}
		if (g_file_test (filename, G_FILE_TEST_IS_REGULAR)) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = g_file_test (filename, G_FILE_TEST_IS_SYMLINK);
		}
		if (!_tmp1_) {
			_inner_error_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_BADF, "File exists, but not a regular file or link");
			if (_inner_error_ != NULL) {
				_g_free0 (content);
				goto __catch4_g_error;
				goto __finally4;
			}
		}
		_tmp3_ = g_file_get_contents (filename, &_tmp2_, &len, &_inner_error_);
		content = (_tmp4_ = _tmp2_, _g_free0 (content), _tmp4_);
		_tmp3_;
		if (_inner_error_ != NULL) {
			_g_free0 (content);
			goto __catch4_g_error;
			goto __finally4;
		}
		parser.start_element = (GCallback) tuntun_connections_xmlconfig_start_element_handler;
		context = g_markup_parse_context_new (&parser, G_MARKUP_TREAT_CDATA_AS_TEXT, self, NULL);
		g_markup_parse_context_parse (context, content, (gssize) string_get_length (content), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (content);
			_g_markup_parse_context_free0 (context);
			goto __catch4_g_error;
			goto __finally4;
		}
		_g_free0 (content);
		_g_markup_parse_context_free0 (context);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			_inner_error_ = _g_error_copy0 (err);
			if (_inner_error_ != NULL) {
				_g_error_free0 (err);
				goto __finally4;
			}
			_g_error_free0 (err);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void tuntun_connections_save (TuntunConnections* self, GError** error) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	tuntun_connections_save_config (self, self->priv->_config_file, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void tuntun_connections_save_config (TuntunConnections* self, const char* filename, GError** error) {
	GError * _inner_error_;
	char* content;
	char* _tmp0_;
	char* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (filename != NULL);
	_inner_error_ = NULL;
	content = NULL;
	content = (_tmp0_ = g_strdup ("<?xml version='1.0'?>\n<connections>\n"), _g_free0 (content), _tmp0_);
	{
		GList* connection_collection;
		GList* connection_it;
		connection_collection = self->items;
		for (connection_it = connection_collection; connection_it != NULL; connection_it = connection_it->next) {
			TuntunConnection* connection;
			connection = _g_object_ref0 ((TuntunConnection*) connection_it->data);
			{
				const char* _tmp1_;
				char* tmp;
				char* _tmp2_;
				_tmp1_ = NULL;
				if (tuntun_connection_info_get_quick_connect (tuntun_connection_get_info (connection))) {
					_tmp1_ = "1";
				} else {
					_tmp1_ = "0";
				}
				tmp = g_markup_printf_escaped ("\t<connection \n\t\tname=\"%s\" \n\t\thost=\"%s\" \n\t\tport=\"%d\" \n\t\tquick-connect=\"%s\" >\n\t</connection>\n", tuntun_connection_info_get_name (tuntun_connection_get_info (connection)), tuntun_connection_info_get_address (tuntun_connection_get_info (connection)), tuntun_connection_info_get_port (tuntun_connection_get_info (connection)), _tmp1_);
				content = (_tmp2_ = g_strconcat (content, tmp, NULL), _g_free0 (content), _tmp2_);
				_g_object_unref0 (connection);
				_g_free0 (tmp);
			}
		}
	}
	content = (_tmp3_ = g_strconcat (content, "</connections>\n", NULL), _g_free0 (content), _tmp3_);
	{
		g_file_set_contents (filename, content, -1, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch5_g_file_error;
			}
			goto __finally5;
		}
	}
	goto __finally5;
	__catch5_g_file_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("tuntun-connections.vala:123: error saving config: %s", err->message);
			_g_error_free0 (err);
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_FILE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (content);
			return;
		} else {
			_g_free0 (content);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_free0 (content);
}


static void tuntun_connections_xmlconfig_start_element_handler (GMarkupParseContext* context, const char* element_name, char** attribute_names, char** attribute_values, void* user_data, GError** error) {
	TuntunConnections* _self_;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (context != NULL);
	g_return_if_fail (element_name != NULL);
	_self_ = _g_object_ref0 (TUNTUN_CONNECTIONS (user_data));
	if (element_name != NULL) {
		_tmp0_ = g_utf8_collate ("connection", element_name) == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		TuntunConnectionInfo* info;
		gboolean _tmp3_ = FALSE;
		info = tuntun_connection_info_new ();
		{
			gint i;
			i = 0;
			{
				gboolean _tmp1_;
				_tmp1_ = TRUE;
				while (TRUE) {
					if (!_tmp1_) {
						i++;
					}
					_tmp1_ = FALSE;
					if (!(attribute_names[i] != NULL)) {
						break;
					}
					if (attribute_names[i] == NULL) {
						continue;
					}
					if (g_utf8_collate ("name", attribute_names[i]) == 0) {
						tuntun_connection_info_set_name (info, attribute_values[i]);
					} else {
						if (g_utf8_collate ("host", attribute_names[i]) == 0) {
							tuntun_connection_info_set_address (info, attribute_values[i]);
						} else {
							if (g_utf8_collate ("port", attribute_names[i]) == 0) {
								tuntun_connection_info_set_port (info, atoi (attribute_values[i]));
							} else {
								if (g_utf8_collate ("quick-connect", attribute_names[i]) == 0) {
									gboolean _tmp2_ = FALSE;
									if (atoi (attribute_values[i]) != 0) {
										_tmp2_ = TRUE;
									} else {
										_tmp2_ = FALSE;
									}
									tuntun_connection_info_set_quick_connect (info, _tmp2_);
								}
							}
						}
					}
				}
			}
		}
		if (tuntun_connection_info_get_name (info) != NULL) {
			_tmp3_ = _vala_strcmp0 (tuntun_connection_info_get_name (info), "") != 0;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			TuntunConnection* connection;
			connection = tuntun_connection_new (info);
			tuntun_connections_add (_self_, connection);
			_g_object_unref0 (connection);
		}
		_g_object_unref0 (info);
	}
	_g_object_unref0 (_self_);
}


static void _tuntun_connections_on_connection_authentication_required_tuntun_connection_authentication_required (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self) {
	tuntun_connections_on_connection_authentication_required (self, _sender, mode, type);
}


static void _tuntun_connections_on_connection_authentication_failed_tuntun_connection_authentication_failed (TuntunConnection* _sender, TuntunAuthenticationModes mode, const char* type, gpointer self) {
	tuntun_connections_on_connection_authentication_failed (self, _sender, mode, type);
}


static void _tuntun_connections_on_connection_fatal_error_tuntun_connection_control_channel_fatal_error (TuntunConnection* _sender, const char* _error_, gpointer self) {
	tuntun_connections_on_connection_fatal_error (self, _sender, _error_);
}


static void _tuntun_connections_on_connection_data_received_tuntun_connection_control_channel_data_received (TuntunConnection* _sender, const char* data, gpointer self) {
	tuntun_connections_on_connection_data_received (self, _sender, data);
}


void tuntun_connections_add (TuntunConnections* self, TuntunConnection* connection) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	tuntun_connection_initialize (connection);
	self->items = g_list_append (self->items, _g_object_ref0 (connection));
	tuntun_connections_on_connection_added (self, connection);
	g_signal_connect (connection, "notify::status", (GCallback) tuntun_connections_connection_notify_property_changed, self);
	g_signal_connect (connection, "notify::control-channel-status", (GCallback) tuntun_connections_connection_notify_property_changed, self);
	g_signal_connect_object (connection, "authentication-required", (GCallback) _tuntun_connections_on_connection_authentication_required_tuntun_connection_authentication_required, self, 0);
	g_signal_connect_object (connection, "authentication-failed", (GCallback) _tuntun_connections_on_connection_authentication_failed_tuntun_connection_authentication_failed, self, 0);
	g_signal_connect_object (connection, "control-channel-fatal-error", (GCallback) _tuntun_connections_on_connection_fatal_error_tuntun_connection_control_channel_fatal_error, self, 0);
	g_signal_connect_object (connection, "control-channel-data-received", (GCallback) _tuntun_connections_on_connection_data_received_tuntun_connection_control_channel_data_received, self, 0);
}


void tuntun_connections_remove (TuntunConnections* self, TuntunConnection* connection) {
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	self->items = g_list_remove (self->items, connection);
	g_signal_handlers_disconnect_by_func (connection, (void*) tuntun_connections_connection_notify_property_changed, self);
	g_signal_handlers_disconnect_matched (connection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("authentication-required", TUNTUN_TYPE_CONNECTION, &_tmp0_, NULL, FALSE), _tmp0_), 0, NULL, (GCallback) _tuntun_connections_on_connection_authentication_required_tuntun_connection_authentication_required, self);
	g_signal_handlers_disconnect_matched (connection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("authentication-failed", TUNTUN_TYPE_CONNECTION, &_tmp1_, NULL, FALSE), _tmp1_), 0, NULL, (GCallback) _tuntun_connections_on_connection_authentication_failed_tuntun_connection_authentication_failed, self);
	g_signal_handlers_disconnect_matched (connection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("control-channel-fatal-error", TUNTUN_TYPE_CONNECTION, &_tmp2_, NULL, FALSE), _tmp2_), 0, NULL, (GCallback) _tuntun_connections_on_connection_fatal_error_tuntun_connection_control_channel_fatal_error, self);
	g_signal_handlers_disconnect_matched (connection, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("control-channel-data-received", TUNTUN_TYPE_CONNECTION, &_tmp3_, NULL, FALSE), _tmp3_), 0, NULL, (GCallback) _tuntun_connections_on_connection_data_received_tuntun_connection_control_channel_data_received, self);
	tuntun_connections_on_connection_removed (self, connection);
}


static void tuntun_connections_on_connection_data_received (TuntunConnections* self, TuntunConnection* connection, const char* data) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (data != NULL);
	tuntun_connections_on_connection_activity (self, connection);
}


static void tuntun_connections_real_on_connection_activity (TuntunConnections* self, TuntunConnection* connection) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_signal_emit_by_name (self, "connection-activity", connection);
}


void tuntun_connections_on_connection_activity (TuntunConnections* self, TuntunConnection* connection) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_activity (self, connection);
}


static void tuntun_connections_real_on_connection_fatal_error (TuntunConnections* self, TuntunConnection* connection, const char* _error_) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (_error_ != NULL);
	g_signal_emit_by_name (self, "connection-fatal-error", connection, _error_);
}


void tuntun_connections_on_connection_fatal_error (TuntunConnections* self, TuntunConnection* connection, const char* _error_) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_fatal_error (self, connection, _error_);
}


static void tuntun_connections_real_on_connection_authentication_required (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (type != NULL);
	g_signal_emit_by_name (self, "authentication-required", connection, mode, type);
}


void tuntun_connections_on_connection_authentication_required (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_authentication_required (self, connection, mode, type);
}


static void tuntun_connections_real_on_connection_authentication_failed (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (type != NULL);
	g_signal_emit_by_name (self, "authentication-failed", connection, mode, type);
}


void tuntun_connections_on_connection_authentication_failed (TuntunConnections* self, TuntunConnection* connection, TuntunAuthenticationModes mode, const char* type) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_authentication_failed (self, connection, mode, type);
}


static void tuntun_connections_real_on_connection_removed (TuntunConnections* self, TuntunConnection* connection) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_signal_emit_by_name (self, "connection-removed", connection);
}


void tuntun_connections_on_connection_removed (TuntunConnections* self, TuntunConnection* connection) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_removed (self, connection);
}


static void tuntun_connections_real_on_connection_added (TuntunConnections* self, TuntunConnection* connection) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_signal_emit_by_name (self, "connection-added", connection);
}


void tuntun_connections_on_connection_added (TuntunConnections* self, TuntunConnection* connection) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_added (self, connection);
}


static gboolean _tuntun_connections_connection_recheck_gsource_func (gpointer self) {
	return tuntun_connections_connection_recheck (self);
}


static void tuntun_connections_real_on_connection_status_changed (TuntunConnections* self, TuntunConnection* connection) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_signal_emit_by_name (self, "connection-status-changed", connection);
	if (self->priv->_timeout_id == 0) {
		_tmp0_ = tuntun_connection_get_control_channel_status (connection) == TUNTUN_CONNECTION_STATES_ERROR;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		self->priv->_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 15, _tuntun_connections_connection_recheck_gsource_func, g_object_ref (self), g_object_unref);
	}
}


void tuntun_connections_on_connection_status_changed (TuntunConnections* self, TuntunConnection* connection) {
	TUNTUN_CONNECTIONS_GET_CLASS (self)->on_connection_status_changed (self, connection);
}


static gboolean tuntun_connections_connection_recheck (TuntunConnections* self) {
	gboolean result;
	gboolean _result_;
	g_return_val_if_fail (self != NULL, FALSE);
	_result_ = FALSE;
	{
		GList* connection_collection;
		GList* connection_it;
		connection_collection = self->items;
		for (connection_it = connection_collection; connection_it != NULL; connection_it = connection_it->next) {
			TuntunConnection* connection;
			connection = _g_object_ref0 ((TuntunConnection*) connection_it->data);
			{
				if (tuntun_connection_get_control_channel_status (connection) == TUNTUN_CONNECTION_STATES_ERROR) {
					tuntun_connection_reinitialize (connection);
					_result_ = TRUE;
				}
				_g_object_unref0 (connection);
			}
		}
	}
	if (!_result_) {
		self->priv->_timeout_id = (guint) 0;
	}
	result = _result_;
	return result;
}


static void tuntun_connections_connection_notify_property_changed (TuntunConnection* connection, GParamSpec* param, TuntunConnections* connections) {
	g_return_if_fail (connection != NULL);
	g_return_if_fail (param != NULL);
	g_return_if_fail (connections != NULL);
	tuntun_connections_on_connection_status_changed (connections, connection);
}


TuntunConnections* tuntun_connections_construct (GType object_type) {
	TuntunConnections * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


TuntunConnections* tuntun_connections_new (void) {
	return tuntun_connections_construct (TUNTUN_TYPE_CONNECTIONS);
}


static GObject * tuntun_connections_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	TuntunConnections * self;
	parent_class = G_OBJECT_CLASS (tuntun_connections_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = TUNTUN_CONNECTIONS (obj);
	{
		GList* _tmp0_;
		self->items = (_tmp0_ = NULL, __g_list_free_g_object_unref0 (self->items), _tmp0_);
		tuntun_connections_load (self);
	}
	return obj;
}


static void tuntun_connections_class_init (TuntunConnectionsClass * klass) {
	tuntun_connections_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TuntunConnectionsPrivate));
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_activity = tuntun_connections_real_on_connection_activity;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_fatal_error = tuntun_connections_real_on_connection_fatal_error;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_authentication_required = tuntun_connections_real_on_connection_authentication_required;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_authentication_failed = tuntun_connections_real_on_connection_authentication_failed;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_removed = tuntun_connections_real_on_connection_removed;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_added = tuntun_connections_real_on_connection_added;
	TUNTUN_CONNECTIONS_CLASS (klass)->on_connection_status_changed = tuntun_connections_real_on_connection_status_changed;
	G_OBJECT_CLASS (klass)->constructor = tuntun_connections_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuntun_connections_finalize;
	g_signal_new ("connection_added", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNTUN_TYPE_CONNECTION);
	g_signal_new ("connection_removed", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNTUN_TYPE_CONNECTION);
	g_signal_new ("connection_status_changed", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNTUN_TYPE_CONNECTION);
	g_signal_new ("connection_activity", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNTUN_TYPE_CONNECTION);
	g_signal_new ("connection_fatal_error", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, TUNTUN_TYPE_CONNECTION, G_TYPE_STRING);
	g_signal_new ("authentication_required", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM_STRING, G_TYPE_NONE, 3, TUNTUN_TYPE_CONNECTION, TUNTUN_TYPE_AUTHENTICATION_MODES, G_TYPE_STRING);
	g_signal_new ("authentication_failed", TUNTUN_TYPE_CONNECTIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM_STRING, G_TYPE_NONE, 3, TUNTUN_TYPE_CONNECTION, TUNTUN_TYPE_AUTHENTICATION_MODES, G_TYPE_STRING);
}


static void tuntun_connections_instance_init (TuntunConnections * self) {
	self->priv = TUNTUN_CONNECTIONS_GET_PRIVATE (self);
	self->priv->_timeout_id = (guint) 0;
}


static void tuntun_connections_finalize (GObject* obj) {
	TuntunConnections * self;
	self = TUNTUN_CONNECTIONS (obj);
	_g_free0 (self->priv->_config_file);
	__g_list_free_g_object_unref0 (self->items);
	G_OBJECT_CLASS (tuntun_connections_parent_class)->finalize (obj);
}


GType tuntun_connections_get_type (void) {
	static GType tuntun_connections_type_id = 0;
	if (tuntun_connections_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (TuntunConnectionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuntun_connections_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TuntunConnections), 0, (GInstanceInitFunc) tuntun_connections_instance_init, NULL };
		tuntun_connections_type_id = g_type_register_static (G_TYPE_OBJECT, "TuntunConnections", &g_define_type_info, 0);
	}
	return tuntun_connections_type_id;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}



static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_ENUM_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM_STRING) (gpointer data1, gpointer arg_1, gint arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), g_value_get_string (param_values + 3), data2);
}



