/* tuntun-utils.c generated by valac, the Vala compiler
 * generated from tuntun-utils.vala, do not modify */

/*
 *  tuntun-utils.vala is a part of Tuntun
 *
 *  Tuntun: a simple applet to manage OpenVPN connections
 *
 *  Copyright (C) 2008  Andrea Del Signore
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 *  Author:
 *     Andrea Del Signore <sejerpz@tin.it>       
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gobject/gvaluecollector.h>


#define TUNTUN_TYPE_UTILS (tuntun_utils_get_type ())
#define TUNTUN_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNTUN_TYPE_UTILS, TuntunUtils))
#define TUNTUN_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNTUN_TYPE_UTILS, TuntunUtilsClass))
#define TUNTUN_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNTUN_TYPE_UTILS))
#define TUNTUN_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNTUN_TYPE_UTILS))
#define TUNTUN_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNTUN_TYPE_UTILS, TuntunUtilsClass))

typedef struct _TuntunUtils TuntunUtils;
typedef struct _TuntunUtilsClass TuntunUtilsClass;
typedef struct _TuntunUtilsPrivate TuntunUtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _TuntunParamSpecUtils TuntunParamSpecUtils;

struct _TuntunUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TuntunUtilsPrivate * priv;
};

struct _TuntunUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (TuntunUtils *self);
};

struct _TuntunParamSpecUtils {
	GParamSpec parent_instance;
};


static GtkBuilder* tuntun_utils_ui;
static GtkBuilder* tuntun_utils_ui = NULL;
static gpointer tuntun_utils_parent_class = NULL;

gpointer tuntun_utils_ref (gpointer instance);
void tuntun_utils_unref (gpointer instance);
GParamSpec* tuntun_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void tuntun_value_set_utils (GValue* value, gpointer v_object);
gpointer tuntun_value_get_utils (const GValue* value);
GType tuntun_utils_get_type (void);
enum  {
	TUNTUN_UTILS_DUMMY_PROPERTY
};
#define TUNTUN_UTILS_GNOME_DOT_GNOME ".gnome2"
char* tuntun_utils_gnome_util_home_file (const char* afile);
char* tuntun_utils_get_image_path (const char* id);
char* tuntun_utils_get_ui_path (const char* id);
static void tuntun_utils_initialize_gtk_builder (void);
GtkBuilder* tuntun_utils_get_ui (void);
void tuntun_utils_display_error (const char* function, const char* message);
TuntunUtils* tuntun_utils_new (void);
TuntunUtils* tuntun_utils_construct (GType object_type);
static void tuntun_utils_finalize (TuntunUtils* obj);



char* tuntun_utils_gnome_util_home_file (const char* afile) {
	char* result;
	g_return_val_if_fail (afile != NULL, NULL);
	result = g_build_filename (g_get_home_dir (), TUNTUN_UTILS_GNOME_DOT_GNOME, afile, NULL);
	return result;
}


char* tuntun_utils_get_image_path (const char* id) {
	char* result;
	g_return_val_if_fail (id != NULL, NULL);
	result = g_build_filename (PACKAGE_DATA_DIR, "tuntun", "pixmaps", id, NULL);
	return result;
}


char* tuntun_utils_get_ui_path (const char* id) {
	char* result;
	g_return_val_if_fail (id != NULL, NULL);
	result = g_build_filename (PACKAGE_DATA_DIR, "tuntun", "ui", id, NULL);
	return result;
}


GtkBuilder* tuntun_utils_get_ui (void) {
	GtkBuilder* result;
	if (tuntun_utils_ui == NULL) {
		tuntun_utils_initialize_gtk_builder ();
	}
	result = tuntun_utils_ui;
	return result;
}


static void tuntun_utils_initialize_gtk_builder (void) {
	GError * _inner_error_;
	_inner_error_ = NULL;
	{
		GtkBuilder* _tmp0_;
		char* _tmp1_;
		tuntun_utils_ui = (_tmp0_ = gtk_builder_new (), _g_object_unref0 (tuntun_utils_ui), _tmp0_);
		gtk_builder_set_translation_domain (tuntun_utils_ui, GETTEXT_PACKAGE);
		gtk_builder_add_from_file (tuntun_utils_ui, _tmp1_ = tuntun_utils_get_ui_path ("tuntun.ui"), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
			goto __finally6;
		}
		_g_free0 (_tmp1_);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
			tuntun_utils_display_error ("initialize_gtk_builder", err->message);
			_g_error_free0 (err);
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void tuntun_utils_display_error (const char* function, const char* message) {
	GtkMessageDialog* dialog;
	g_return_if_fail (function != NULL);
	g_return_if_fail (message != NULL);
	dialog = g_object_ref_sink ((GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, message));
	g_object_set (dialog, "secondary-text", function, NULL);
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_object_destroy ((GtkObject*) dialog);
	_g_object_unref0 (dialog);
}


TuntunUtils* tuntun_utils_construct (GType object_type) {
	TuntunUtils* self;
	self = (TuntunUtils*) g_type_create_instance (object_type);
	return self;
}


TuntunUtils* tuntun_utils_new (void) {
	return tuntun_utils_construct (TUNTUN_TYPE_UTILS);
}


static void tuntun_value_utils_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void tuntun_value_utils_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		tuntun_utils_unref (value->data[0].v_pointer);
	}
}


static void tuntun_value_utils_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = tuntun_utils_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer tuntun_value_utils_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* tuntun_value_utils_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		TuntunUtils* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = tuntun_utils_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* tuntun_value_utils_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	TuntunUtils** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = tuntun_utils_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* tuntun_param_spec_utils (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	TuntunParamSpecUtils* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TUNTUN_TYPE_UTILS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer tuntun_value_get_utils (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUNTUN_TYPE_UTILS), NULL);
	return value->data[0].v_pointer;
}


void tuntun_value_set_utils (GValue* value, gpointer v_object) {
	TuntunUtils* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TUNTUN_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TUNTUN_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		tuntun_utils_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tuntun_utils_unref (old);
	}
}


static void tuntun_utils_class_init (TuntunUtilsClass * klass) {
	tuntun_utils_parent_class = g_type_class_peek_parent (klass);
	TUNTUN_UTILS_CLASS (klass)->finalize = tuntun_utils_finalize;
}


static void tuntun_utils_instance_init (TuntunUtils * self) {
	self->ref_count = 1;
}


static void tuntun_utils_finalize (TuntunUtils* obj) {
	TuntunUtils * self;
	self = TUNTUN_UTILS (obj);
}


GType tuntun_utils_get_type (void) {
	static GType tuntun_utils_type_id = 0;
	if (tuntun_utils_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { tuntun_value_utils_init, tuntun_value_utils_free_value, tuntun_value_utils_copy_value, tuntun_value_utils_peek_pointer, "p", tuntun_value_utils_collect_value, "p", tuntun_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (TuntunUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuntun_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TuntunUtils), 0, (GInstanceInitFunc) tuntun_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		tuntun_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TuntunUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return tuntun_utils_type_id;
}


gpointer tuntun_utils_ref (gpointer instance) {
	TuntunUtils* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void tuntun_utils_unref (gpointer instance) {
	TuntunUtils* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TUNTUN_UTILS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




